MODULE MODD_MGN2MECH

USE MODD_MEGAN, ONLY : N_MGN_SPC, N_MGN_PFT
!=======================================================================
!  EF_MGN20.EXT
!  This include file contains EF for 20 MEGAN species.  The values in
!  this file must be in the same order as in SPC_MGN.EXT
!
!  MEGAN v2.1
!  INPUT version 210
!
!  History:
!  Who          When       What
!  ---------------------------------------------------------------------
!  Tan          12/02/2006 - Creates this file
!  Guenther A.  08/11/2007 - Creates this file again with updates and move
!                          from v2.0 to v2.02
!  Xuemei Wang and Alex 26/07/2011-Extend EFs to 16 PFTs
!  Jiang X.     05/07/2012 - Updates EFs with new values from Guenther
!=======================================================================

!     EF_NT_EG_TEMP EF_NT_DC_BORL EF_NT_EG_BORL EF_BT_EG_TROP EF_BT_EG_TEMP
!     EF_BT_DC_TROP EF_BT_DC_TEMP EF_BT_DC_BORL EF_SB_EG_TEMP EF_SB_DC_TEMP
!     EF_SB_DC_BORL EF_GS_C3_COLD EF_GS_C3_COOL EF_GS_C3_WARM EF_CROP EF_CORN

REAL,DIMENSION(N_MGN_PFT,N_MGN_SPC) :: XEF_ALL = RESHAPE( (/  & 
 -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,&
 -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,&
 -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,&
 -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,&
 -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,&
 -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,&
 -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,&
 -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,&
180., 170., 180., 150., 150., 150., 150., 150., 110., 200., 110.,   5.,   5.,   5.,   5.,   5.,&
 40.,  40.,  40.,  60.,  40.,  60.,  40.,  40.,  40.,  40.,  40.,   3.,   3.,   3.,   4.,   4.,&
 80.,  80.,  80.,  60.,  40.,  60.,  40.,  40.,  50.,  50.,  50.,   1.,   1.,   1.,   2.,   4.,&
120., 120., 120., 120., 100., 120., 100., 100., 100., 100., 100.,   2.,   2.,   2.,   2.,   2.,&
 -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,&
900., 900., 900., 500., 900., 500., 900., 900., 900., 900., 900., 500., 500., 500., 900., 900.,&
240., 240., 240., 240., 240., 240., 240., 240., 240., 240., 240.,  80.,  80.,  80.,  80.,  80.,&
600., 600., 600., 600., 600., 600., 600., 600., 600., 600., 600., 600., 600., 600., 600., 600.,&
 -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,  -1.,&
500., 500., 500., 500., 500., 500., 500., 500., 500., 500., 500.,  80.,  80.,  80.,  80.,  80.,&
300., 300., 300., 300., 300., 300., 300., 300., 300., 300., 300., 300., 300., 300., 300., 300.,&
140., 140., 140., 140., 140., 140., 140., 140., 140., 140., 140., 140., 140., 140., 140., 140. /),&
SHAPE=(/N_MGN_PFT,N_MGN_SPC/), ORDER=(/1,2/)   )

!=======================================================================
!  EFFS_MGN20T150.EXT
!  This include file contains EF fractions for speciation from 20 MEGAN
!  categories to 150 species.  The values in this file must be in the
!  same order as in MAP_MGN20T150.EXT
!
!  MEGAN v2.1
!  INPUT version 210
!
!  History:
!  Who          When       What
!  ---------------------------------------------------------------------
!  Tan          12/02/06 - Creates this file
!  Guenther A.  08/11/07 - Move from MEGAN v2.0 to MEGAN v2.02 with update on
!                          Nitrogen gas.
!  Guenther A.  26/07/2011-Extend EFs for 16 PFTs
!  Jiang X.     05/07/12 - Update EF fractions with new values from Guenther
!=======================================================================
                                                                                   
INTEGER,PARAMETER :: N_EFFS_SPC=150   ! Number of chemical species

!     EFFS_NT_EG_TEMP EFFS_NT_DC_BORL EFFS_NT_EG_BORL EFFS_BT_EG_TROP EFFS_BT_EG_TEMP
!     EFFS_BT_DC_TROP EFFS_BT_DC_TEMP EFFS_BT_DC_BORL EFSF_SB_EG_TEMP EFFS_SB_DC_TEMP
!     EFFS_SB_DC_BORL EFFS_GS_C3_COLD EFFS_GS_C3_COOL EFFS_GS_C3_WARM EFFS_CROP EFFS_CORN


REAL,DIMENSION(N_MGN_PFT,N_EFFS_SPC) :: XEFFS_ALL = RESHAPE( (/  &
 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000,&
 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000,&
 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000,&
 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000,&
 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000,&
 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000,&
 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000,&
 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000,&
 0.006, 0.006, 0.006, 0.011, 0.011, 0.011, 0.011, 0.011, 0.009, 0.009, 0.009, 0.010, 0.010, 0.010, 0.010, 0.010,&
 0.055, 0.055, 0.055, 0.057, 0.057, 0.057, 0.057, 0.057, 0.046, 0.046, 0.046, 0.042, 0.042, 0.042, 0.042, 0.042,&
 0.017, 0.017, 0.017, 0.034, 0.034, 0.034, 0.034, 0.034, 0.028, 0.028, 0.028, 0.031, 0.031, 0.031, 0.031, 0.031,&
 0.055, 0.055, 0.055, 0.046, 0.046, 0.046, 0.046, 0.046, 0.046, 0.046, 0.046, 0.042, 0.042, 0.042, 0.042, 0.042,&
 0.033, 0.033, 0.033, 0.011, 0.011, 0.011, 0.011, 0.011, 0.037, 0.037, 0.037, 0.042, 0.042, 0.042, 0.042, 0.042,&
 0.055, 0.055, 0.055, 0.057, 0.057, 0.057, 0.057, 0.057, 0.046, 0.046, 0.046, 0.042, 0.042, 0.042, 0.042, 0.042,&
 0.055, 0.055, 0.055, 0.057, 0.057, 0.057, 0.057, 0.057, 0.046, 0.046, 0.046, 0.042, 0.042, 0.042, 0.042, 0.042,&
 0.067, 0.067, 0.067, 0.057, 0.057, 0.057, 0.057, 0.057, 0.055, 0.055, 0.055, 0.062, 0.062, 0.062, 0.062, 0.062,&
 0.160, 0.160, 0.160, 0.057, 0.057, 0.057, 0.057, 0.057, 0.092, 0.092, 0.092, 0.104, 0.104, 0.104, 0.104, 0.104,&
 0.248, 0.248, 0.248, 0.180, 0.180, 0.180, 0.180, 0.180, 0.186, 0.186, 0.186, 0.146, 0.146, 0.146, 0.146, 0.146,&
 0.005, 0.005, 0.005, 0.010, 0.010, 0.010, 0.010, 0.010, 0.008, 0.008, 0.008, 0.008, 0.008, 0.008, 0.008, 0.008,&
 0.002, 0.002, 0.002, 0.003, 0.003, 0.003, 0.003, 0.003, 0.003, 0.003, 0.003, 0.004, 0.004, 0.004, 0.004, 0.004,&
 0.006, 0.006, 0.006, 0.011, 0.011, 0.011, 0.011, 0.011, 0.009, 0.009, 0.009, 0.010, 0.010, 0.010, 0.010, 0.010,&
 0.022, 0.022, 0.022, 0.046, 0.046, 0.046, 0.046, 0.046, 0.037, 0.037, 0.037, 0.042, 0.042, 0.042, 0.042, 0.042,&
 0.006, 0.006, 0.006, 0.011, 0.011, 0.011, 0.011, 0.011, 0.009, 0.009, 0.009, 0.010, 0.010, 0.010, 0.010, 0.010,&
 0.002, 0.002, 0.002, 0.003, 0.003, 0.003, 0.003, 0.003, 0.003, 0.003, 0.003, 0.004, 0.004, 0.004, 0.004, 0.004,&
 0.033, 0.033, 0.033, 0.034, 0.034, 0.034, 0.034, 0.034, 0.046, 0.046, 0.046, 0.042, 0.042, 0.042, 0.042, 0.042,&
 0.006, 0.006, 0.006, 0.011, 0.011, 0.011, 0.011, 0.011, 0.009, 0.009, 0.009, 0.010, 0.010, 0.010, 0.010, 0.010,&
 0.002, 0.002, 0.002, 0.003, 0.003, 0.003, 0.003, 0.003, 0.003, 0.003, 0.003, 0.004, 0.004, 0.004, 0.004, 0.004,&
 0.028, 0.028, 0.028, 0.011, 0.011, 0.011, 0.011, 0.011, 0.046, 0.046, 0.046, 0.042, 0.042, 0.042, 0.042, 0.042,&
 0.006, 0.006, 0.006, 0.002, 0.002, 0.002, 0.002, 0.002, 0.009, 0.009, 0.009, 0.010, 0.010, 0.010, 0.010, 0.010,&
 0.011, 0.011, 0.011, 0.057, 0.057, 0.057, 0.057, 0.057, 0.037, 0.037, 0.037, 0.042, 0.042, 0.042, 0.042, 0.042,&
 0.004, 0.004, 0.004, 0.008, 0.008, 0.008, 0.008, 0.008, 0.006, 0.006, 0.006, 0.006, 0.006, 0.006, 0.006, 0.006,&
 0.060, 0.060, 0.060, 0.138, 0.138, 0.138, 0.138, 0.138, 0.111, 0.111, 0.111, 0.125, 0.125, 0.125, 0.125, 0.125,&
 0.003, 0.003, 0.003, 0.007, 0.007, 0.007, 0.007, 0.007, 0.006, 0.006, 0.006, 0.006, 0.006, 0.006, 0.006, 0.006,&
 0.017, 0.017, 0.017, 0.034, 0.034, 0.034, 0.034, 0.034, 0.028, 0.028, 0.028, 0.031, 0.031, 0.031, 0.031, 0.031,&
 0.003, 0.003, 0.003, 0.007, 0.007, 0.007, 0.007, 0.007, 0.006, 0.006, 0.006, 0.006, 0.006, 0.006, 0.006, 0.006,&
 0.017, 0.017, 0.017, 0.030, 0.030, 0.030, 0.030, 0.030, 0.024, 0.024, 0.024, 0.027, 0.027, 0.027, 0.027, 0.027,&
 0.001, 0.001, 0.001, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002,&
 0.003, 0.003, 0.003, 0.001, 0.001, 0.001, 0.001, 0.001, 0.003, 0.003, 0.003, 0.002, 0.002, 0.002, 0.002, 0.002,&
 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000,&
 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000,&
 0.016, 0.016, 0.016, 0.019, 0.019, 0.019, 0.019, 0.019, 0.019, 0.019, 0.019, 0.022, 0.022, 0.022, 0.022, 0.022,&
 0.006, 0.006, 0.006, 0.007, 0.007, 0.007, 0.007, 0.007, 0.008, 0.008, 0.008, 0.011, 0.011, 0.011, 0.011, 0.011,&
 0.144, 0.144, 0.144, 0.084, 0.084, 0.084, 0.084, 0.084, 0.096, 0.096, 0.096, 0.098, 0.098, 0.098, 0.098, 0.098,&
 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.005, 0.005, 0.005, 0.005, 0.005,&
 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.005, 0.005, 0.005, 0.005, 0.005,&
 0.120, 0.120, 0.120, 0.056, 0.056, 0.056, 0.056, 0.056, 0.067, 0.067, 0.067, 0.077, 0.077, 0.077, 0.077, 0.077,&
 0.024, 0.024, 0.024, 0.028, 0.028, 0.028, 0.028, 0.028, 0.029, 0.029, 0.029, 0.033, 0.033, 0.033, 0.033, 0.033,&
 0.012, 0.012, 0.012, 0.014, 0.014, 0.014, 0.014, 0.014, 0.014, 0.014, 0.014, 0.016, 0.016, 0.016, 0.016, 0.016,&
 0.008, 0.008, 0.008, 0.009, 0.009, 0.009, 0.009, 0.009, 0.010, 0.010, 0.010, 0.011, 0.011, 0.011, 0.011, 0.011,&
 0.005, 0.005, 0.005, 0.006, 0.006, 0.006, 0.006, 0.006, 0.006, 0.006, 0.006, 0.005, 0.005, 0.005, 0.005, 0.005,&
 
 0.008, 0.008, 0.008, 0.009, 0.009, 0.009, 0.009, 0.009, 0.010, 0.010, 0.010, 0.011, 0.011, 0.011, 0.011, 0.011,&
 0.012, 0.012, 0.012, 0.014, 0.014, 0.014, 0.014, 0.014, 0.014, 0.014, 0.014, 0.016, 0.016, 0.016, 0.016, 0.016,&
 0.008, 0.008, 0.008, 0.009, 0.009, 0.009, 0.009, 0.009, 0.010, 0.010, 0.010, 0.011, 0.011, 0.011, 0.011, 0.011,&
 0.016, 0.016, 0.016, 0.019, 0.019, 0.019, 0.019, 0.019, 0.019, 0.019, 0.019, 0.022, 0.022, 0.022, 0.022, 0.022,&
 0.234, 0.234, 0.234, 0.276, 0.276, 0.276, 0.276, 0.276, 0.285, 0.285, 0.285, 0.224, 0.224, 0.224, 0.224, 0.224,&
 0.008, 0.008, 0.008, 0.009, 0.009, 0.009, 0.009, 0.009, 0.010, 0.010, 0.010, 0.011, 0.011, 0.011, 0.011, 0.011,&
 0.024, 0.024, 0.024, 0.028, 0.028, 0.028, 0.028, 0.028, 0.029, 0.029, 0.029, 0.033, 0.033, 0.033, 0.033, 0.033,&
 0.004, 0.004, 0.004, 0.005, 0.005, 0.005, 0.005, 0.005, 0.005, 0.005, 0.005, 0.005, 0.005, 0.005, 0.005, 0.005,&
 0.199, 0.199, 0.199, 0.139, 0.139, 0.139, 0.139, 0.139, 0.172, 0.172, 0.172, 0.164, 0.164, 0.164, 0.164, 0.164,&
 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.005, 0.005, 0.005, 0.005, 0.005,&
 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.005, 0.005, 0.005, 0.005, 0.005,&
 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.005, 0.005, 0.005, 0.005, 0.005,&
 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.005, 0.005, 0.005, 0.005, 0.005,&
 0.012, 0.012, 0.012, 0.014, 0.014, 0.014, 0.014, 0.014, 0.014, 0.014, 0.014, 0.016, 0.016, 0.016, 0.016, 0.016,&
 0.040, 0.040, 0.040, 0.046, 0.046, 0.046, 0.046, 0.046, 0.048, 0.048, 0.048, 0.055, 0.055, 0.055, 0.055, 0.055,&
 0.080, 0.080, 0.080, 0.186, 0.186, 0.186, 0.186, 0.186, 0.115, 0.115, 0.115, 0.109, 0.109, 0.109, 0.109, 0.109,&
 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.005, 0.005, 0.005, 0.005, 0.005,&
 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.005, 0.005, 0.005, 0.005, 0.005,&
 0.002, 0.002, 0.002, 0.005, 0.005, 0.005, 0.005, 0.005, 0.002, 0.002, 0.002, 0.005, 0.005, 0.005, 0.005, 0.005,&
 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.005, 0.005, 0.005, 0.005, 0.005,&
 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000,&
 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000,&
 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000,&
 0.005, 0.005, 0.005, 0.005, 0.005, 0.005, 0.005, 0.005, 0.005, 0.005, 0.005, 0.005, 0.005, 0.005, 0.005, 0.005,&
 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000,&
 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000,&
 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000,&
 0.400, 0.400, 0.400, 0.400, 0.400, 0.400, 0.400, 0.400, 0.400, 0.400, 0.400, 0.250, 0.250, 0.250, 0.250, 0.250,&
 0.400, 0.400, 0.400, 0.400, 0.400, 0.400, 0.400, 0.400, 0.400, 0.400, 0.400, 0.250, 0.250, 0.250, 0.250, 0.250,&
 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.150, 0.150, 0.150, 0.150, 0.150,&
 0.080, 0.080, 0.080, 0.080, 0.080, 0.080, 0.080, 0.080, 0.080, 0.080, 0.080, 0.200, 0.200, 0.200, 0.200, 0.200,&
 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.150, 0.150, 0.150, 0.150, 0.150,&
 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001,&
 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001,&
 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001,&
 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010,&
 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001,&
 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001,&
 0.025, 0.025, 0.025, 0.025, 0.025, 0.025, 0.025, 0.025, 0.025, 0.025, 0.025, 0.025, 0.025, 0.025, 0.025, 0.025,&
 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001,&
 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001,&
 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001,&
 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001,&
 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010,&
 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001,&
 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001,&
 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001,&
 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001,&
 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001,&
 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002,&
 
 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010,&
 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001,&
 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001,&
 0.015, 0.015, 0.015, 0.015, 0.015, 0.015, 0.015, 0.015, 0.015, 0.015, 0.015, 0.015, 0.015, 0.015, 0.015, 0.015,&
 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001,&
 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001,&
 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030,&
 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000,&
 0.240, 0.240, 0.240, 0.240, 0.240, 0.240, 0.240, 0.240, 0.240, 0.240, 0.240, 0.240, 0.240, 0.240, 0.240, 0.240,&
 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010,&
 0.580, 0.580, 0.580, 0.580, 0.580, 0.580, 0.580, 0.580, 0.580, 0.580, 0.580, 0.580, 0.580, 0.580, 0.580, 0.580,&
 0.015, 0.015, 0.015, 0.015, 0.015, 0.015, 0.015, 0.015, 0.015, 0.015, 0.015, 0.015, 0.015, 0.015, 0.015, 0.015,&
 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001,&
 0.480, 0.480, 0.480, 0.480, 0.480, 0.480, 0.480, 0.480, 0.480, 0.480, 0.480, 0.480, 0.480, 0.480, 0.480, 0.480,&
 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002,&
 0.003, 0.003, 0.003, 0.003, 0.003, 0.003, 0.003, 0.003, 0.003, 0.003, 0.003, 0.003, 0.003, 0.003, 0.003, 0.003,&
 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001,&
 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002,&
 0.050, 0.050, 0.050, 0.050, 0.050, 0.050, 0.050, 0.050, 0.050, 0.050, 0.050, 0.050, 0.050, 0.050, 0.050, 0.050,&
 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010,&
 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002,&
 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001,&
 0.003, 0.003, 0.003, 0.003, 0.003, 0.003, 0.003, 0.003, 0.003, 0.003, 0.003, 0.003, 0.003, 0.003, 0.003, 0.003,&
 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001,&
 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001,&
 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001,&
 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030,&
 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030,&
 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002,&
 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001,&
 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010,&
 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002,&
 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010,&
 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010, 0.010,&
 0.100, 0.100, 0.100, 0.100, 0.100, 0.100, 0.100, 0.100, 0.100, 0.100, 0.100, 0.100, 0.100, 0.100, 0.100, 0.100,&
 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060,&
 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060,&
 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060,&
 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060, 0.060,&
 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030, 0.030,&
 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001,&
 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001,&
 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001,&
 0.003, 0.003, 0.003, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001,&
 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002, 0.002,&
 0.003, 0.003, 0.003, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001,&
 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001,&
 0.003, 0.003, 0.003, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001,&
 0.003, 0.003, 0.003, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001,&
 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001, 0.001 /),&
SHAPE=(/N_MGN_PFT,N_EFFS_SPC/),  ORDER=(/1,2/) )


!****************************************************************************************************************
!****************************************************************************************************************

INTEGER, PARAMETER :: N_CB05_SPC=19
!
CHARACTER(LEN=4), DIMENSION(N_CB05_SPC) :: CMECH_SPC_CB05=(/& ! Mechanism species name
'ISOP','TERP','PAR ','XYL ','OLE ','NR  ','MEOH','CH4 ','NH3 ','NO  ',&
'ALD2','ETOH','FORM','ALDX','TOL ','IOLE','CO  ','ETHA','ETH '/)


REAL, DIMENSION(N_CB05_SPC) :: XMECH_MWT_CB05=(/&  ! Mechanism species molecular weight
 80.,160., 16.,128., 32., 16., 16., 16., 17., 46., 32., 32., 16., 32.,112., 64.,&
 28., 32., 28./)

INTEGER, PARAMETER :: N_CB05=204

CHARACTER(LEN=16), DIMENSION(N_CB05) :: CSPMH_NAM_CB05=(/&  ! speciated species name
'isoprene       ','myrcene        ','sabinene       ','limonene       ','carene_3       ','ocimene_t_b    ',&
'pinene_b       ','pinene_a       ','2met_styrene   ','2met_styrene   ','2met_styrene   ','cymene_p       ',&
'cymene_p       ','cymene_o       ','cymene_o       ','phellandrene_a ','thujene_a      ','terpinene_a    ',&
'terpinene_g    ','terpinolene    ','phellandrene_b ','camphene       ','bornene        ','fenchene_a     ',&
'ocimene_al     ','ocimene_c_b    ','tricyclene     ','tricyclene     ','estragole      ','camphor        ',&
'camphor        ','fenchone       ','fenchone       ','piperitone     ','thujone_a      ','thujone_a      ',&
'thujone_b      ','thujone_b      ','cineole_1_8    ','cineole_1_8    ','borneol        ','borneol        ',&
'linalool       ','terpineol_4    ','terpineol_a    ','linalool_OXD_c ','linalool_OXD_t ','ionone_b       ',&
'ionone_b       ','bornyl_ACT     ','bornyl_ACT     ','farnescene_a   ','caryophyllene_b','acoradiene     ',&
'aromadendrene  ','bergamotene_a  ','bergamotene_b  ','bisabolene_a   ','bisabolene_b   ','bourbonene_b   ',&
'cadinene_d     ','cadinene_g     ','cedrene_a      ','copaene_a      ','cubebene_a     ','cubebene_b     ',&
'elemene_b      ','farnescene_b   ','germacrene_B   ','germacrene_D   ','gurjunene_b    ','humulene_a     ',&
'humulene_g     ','isolongifolene ','longifolene    ','longipinene    ','muurolene_a    ','muurolene_g    ',&
'selinene_b     ','selinene_d     ','nerolidol_c    ','nerolidol_t    ','cedrol         ','cedrol         ',&
'MBO_2m3e2ol    ','MBO_2m3e2ol    ','methanol       ','acetone        ','methane        ','ammonia        ',&
'nitric_OXD     ','acetaldehyde   ','ethanol        ','formic_acid    ','formaldehyde   ','acetic_acid    ',&
'acetic_acid    ','MBO_3m2e1ol    ','MBO_3m2e1ol    ','MBO_3m3e1ol    ','MBO_3m3e1ol    ','benzaldehyde   ',&
'butanone_2     ','decanal        ','decanal        ','dodecene_1     ','dodecene_1     ','geranyl_acetone',&
'geranyl_acetone','heptanal       ','heptanal       ','heptane        ','hexane         ','met_benzoate   ',&
'met_benzoate   ','met_heptenone  ','met_heptenone  ','neryl_acetone  ','neryl_acetone  ','neryl_acetone  ',&
'nonanal        ','nonanal        ','nonenal        ','nonenal        ','nonenal        ','octanal        ',&
'octanal        ','octanol        ','octenol_1e3ol  ','octenol_1e3ol  ','oxopentanal    ','oxopentanal    ',&
'pentane        ','phenyl_CCO     ','phenyl_CCO     ','pyruvic_acid   ','pyruvic_acid   ','terpinyl_ACT_a ',&
'terpinyl_ACT_a ','tetradecene_1  ','tetradecene_1  ','toluene        ','carbon_monoxide','butene         ',&
'butene         ','ethane         ','ethene         ','propane        ','propane        ','propene        ',&
'propene        ','diallyl_2s     ','diallyl_2s     ','2met_2s        ','2met_s         ','met_chloride   ',&
'met_bromide    ','met_iodide     ','met_mercaptan  ','met_propenyl_2s','met_propenyl_2s','PPPP_2s        ',&
'PPPP_2s        ','2met_nonatriene','met_salicylate ','met_salicylate ','indole         ','indole         ',&
'jasmone        ','jasmone        ','met_jasmonate  ','met_jasmonate  ','3met_3DCTT     ','hexanal        ',&
'hexanal        ','hexanol_1      ','hexenal_c3     ','hexenal_c3     ','hexenal_t2     ','hexenal_t2     ',&
'hexenol_c3     ','hexenol_c3     ','hexenyl_ACT_c3 ','hexenyl_ACT_c3 ','hexenyl_ACT_c3 ','homosalate     ',&
'homosalate     ','Ehsalate       ','Ehsalate       ','pentanal       ','pentanal       ','heptanone      ',&
'anisole        ','verbenene      ','benzyl-acetate ','benzyl-acetate ','benzyl-acetate ','myrtenal       ',&
'benzyl-alcohol ','meta-cymenene  ','meta-cymenene  ','ipsenol        ','Napthalene     ','Napthalene     '/)
!
INTEGER, DIMENSION(N_CB05) :: NSPMH_MAP_CB05=(/&            ! speciated species name
  1,  2,  3,  4,  5,  6,  7,  8,  9,  9,  9, 10, 10, 11, 11, 12,&
 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 23, 24, 25, 25, 26,&
 26, 27, 28, 28, 29, 29, 30, 30, 31, 31, 32, 33, 34, 35, 36, 37,& 
 37, 38, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51,&
 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67,&
 68, 69, 70, 70, 71, 71, 72, 73, 74, 75, 77, 78, 79, 80, 81, 82,&
 82, 83, 83, 84, 84, 85, 86, 87, 87, 88, 88, 89, 89, 90, 90, 91,&
 92, 93, 93, 94, 94, 95, 95, 95, 96, 96, 97, 97, 97, 98, 98, 99,&
100,100,101,101,102,103,103,104,104,105,105,106,106,107,108,109,&
109,110,111,113,113,114,114,117,117,118,119,120,121,122,124,125,&
125,126,126,127,128,128,129,129,130,130,131,131,132,133,133,134,&
135,135,136,136,137,137,138,138,138,139,139,140,140,141,141,142,&
143,144,145,145,145,146,147,148,148,149,150,150/)
!
CHARACTER(LEN=4), DIMENSION(N_CB05) :: CMECH_NAM_CB05=(/&  ! mechanism species
'ISOP','TERP','TERP','TERP','TERP','TERP','TERP','TERP','PAR ','XYL ','OLE ','PAR ','XYL ','PAR ','XYL ','TERP',&
'TERP','TERP','TERP','TERP','TERP','TERP','TERP','TERP','TERP','TERP','PAR ','NR  ','TERP','PAR ','NR  ','PAR ',&
'NR  ','TERP','PAR ','NR  ','PAR ','NR  ','PAR ','NR  ','PAR ','NR  ','TERP','TERP','TERP','TERP','TERP','TERP',&
'NR  ','PAR ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ',&
'NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ',&
'NR  ','NR  ','PAR ','NR  ','OLE ','PAR ','MEOH','PAR ','CH4 ','NH3 ','NO  ','ALD2','ETOH','NR  ','FORM','PAR ',&
'NR  ','ALDX','PAR ','FORM','PAR ','TOL ','PAR ','ALDX','PAR ','OLE ','PAR ','TERP','NR  ','ALDX','PAR ','PAR ',&
'PAR ','TOL ','NR  ','PAR ','ALDX','IOLE','PAR ','NR  ','ALDX','PAR ','PAR ','IOLE','ALDX','ALDX','PAR ','PAR ',&
'PAR ','OLE ','PAR ','ALDX','PAR ','TOL ','ALDX','FORM','ALDX','TERP','NR  ','PAR ','OLE ','TOL ','CO  ','OLE ',&
'PAR ','ETHA','ETH ','PAR ','NR  ','OLE ','PAR ','PAR ','OLE ','PAR ','PAR ','NR  ','NR  ','NR  ','PAR ','PAR ',&
'OLE ','PAR ','OLE ','TERP','TOL ','NR  ','TOL ','NR  ','TERP','NR  ','TERP','NR  ','NR  ','ALDX','PAR ','PAR ',&
'IOLE','ALDX','IOLE','ALDX','PAR ','IOLE','PAR ','IOLE','NR  ','TERP','NR  ','TERP','NR  ','ALDX','PAR ','PAR ',&
'TOL ','TERP','TOL ','PAR ','NR  ','TERP','TOL ','XYL ','PAR ','TERP','XYL ','PAR '/)
!
INTEGER, DIMENSION(N_CB05) :: NMECH_MAP_CB05=(/&     ! mechanism species mapped
 1, 2, 2, 2, 2, 2, 2, 2, 3, 4, 5, 3, 4, 3, 4, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 3, 6, 2, 3, 6, 3,&
 6, 2, 3, 6, 3, 6, 3, 6, 3, 6, 2, 2, 2, 2, 2, 2, 6, 3, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6,&
 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 3, 6, 5, 3, 7, 3, 8, 9,10,11,12, 6,13, 3,&
 6,14, 3,13, 3,15, 3,14, 3, 5, 3, 2, 6,14, 3, 3, 3,15, 6, 3,14,16, 3, 6,14, 3, 3,16,14,14, 3, 3,&
 3, 5, 3,14, 3,15,14,13,14, 2, 6, 3, 5,15,17, 5, 3,18,19, 3, 6, 5, 3, 3, 5, 3, 3, 6, 6, 6, 3, 3,&
 5, 3, 5, 2,15, 6,15, 6, 2, 6, 2, 6, 6,14, 3, 3,16,14,16,14, 3,16, 3,16, 6, 2, 6, 2, 6,14, 3, 3,&
15, 2,15, 3, 6, 2,15, 4, 3, 2, 4, 3/)

!
REAL, DIMENSION(N_CB05)  :: XCONV_FAC_CB05=(/&   ! conversion factor
  1.,  1.,  1.,  1.,  1.,  1.,  1.,  1.,  1.,  1., 0.5,  2.,  1.,  2.,  1.,  1.,&
  1.,  1.,  1.,  1.,  1.,  1.,  1.,  1.,  1.,  1.,  9.,  1.,  1.,  8.,  2.,  8.,&
  2.,  1.,  9.,  1.,  9.,  1.,  9.,  1.,  8.,  2.,  1.,  1.,  1.,  1.,  1.,  1.,&
  3.,  6.,  6., 15., 15., 15., 15., 15., 15., 15., 15., 15., 15., 15., 15., 15.,&
 15., 15., 15., 15., 15., 15., 15., 15., 15., 15., 15., 15., 15., 15., 15., 15.,&
 15., 15., 13.,  2.,  1.,  3.,  1.,  3.,  1.,  1.,  1.,  1.,  1.,  1.,  1.,  1.,&
  1.,  1.,  3.,  1.,  4.,  1.,  4.,  1.,  8.,  1., 10.,  1.,  3.,  1.,  5.,  7.,&
  6.,  1.,  1.,  6.,  1.,  1.,  8.,  1.,  1.,  7.,  3.,  1.,  1.,  1.,  6.,  8.,&
  6.,  1.,  3.,  1.,  5.,  1., 0.5,  1.,  1.,  1.,  2., 12.,  1.,  1.,  1.,  1.,&
  2.,  1.,  1., 1.5, 1.5,  1.,  1.,  2.,  2.,  2.,  2.,  1.,  1.,  1.,  1.,  2.,&
  1.,  4.,  1.,  1.,  1.,  1.,  1.,  1.,  1.,  1.,  1.,  3., 16.,  1.,  4.,  6.,&
  1.,  1.,  1.,  1.,  2.,  1.,  3.,  1.,  1.,  1.,  3.,  1.,  3.,  1.,  3.,  7.,&
  1.,  1.,  1.,  1.,  1.,  1.,  1.,  1.,  2.,  1.,  1.,  2./)


!****************************************************************************************************************
!****************************************************************************************************************

INTEGER, PARAMETER :: N_CB6_SPC=24

CHARACTER(LEN=4), DIMENSION(N_CB6_SPC) :: CMECH_SPC_CB6=(/&  ! Mechanism species name
'ISOP','TERP','PAR ','XYL ','OLE ','NR  ','MEOH','CH4 ','NH3 ','NO  ',&
'ALD2','ETOH','FORM','ALDX','TOL ','IOLE','CO  ','ETHA','ETH ','ETHY',&
'PRPA','BENZ','ACET','KET '/)

REAL, DIMENSION(N_CB6_SPC) :: XMECH_MWT_CB6=(/&  ! Mechanism species molecular weight
 80.,160., 16.,128., 32., 16., 16., 16.,17., 46., 32., 32., 16., 32.,112., 64.,&
 28., 32., 28., 26., 44., 78., 58., 58./)


INTEGER, PARAMETER :: N_CB6=210

CHARACTER(LEN=15), DIMENSION(N_CB6) :: CSPMH_NAM_CB6=(/&
'isoprene       ','myrcene        ','sabinene       ','limonene       ','carene_3       ','ocimene_t_b    ',&
'pinene_b       ','pinene_a       ','2met_styrene   ','2met_styrene   ','2met_styrene   ','cymene_p       ',&
'cymene_p       ','cymene_o       ','cymene_o       ','phellandrene_a ','thujene_a      ','terpinene_a    ',&
'terpinene_g    ','terpinolene    ','phellandrene_b ','camphene       ','bornene        ','fenchene_a     ',&
'ocimene_al     ','ocimene_c_b    ','tricyclene     ','tricyclene     ','estragole      ','camphor        ',&
'camphor        ','fenchone       ','fenchone       ','piperitone     ','thujone_a      ','thujone_a      ',&
'thujone_b      ','thujone_b      ','cineole_1_8    ','cineole_1_8    ','borneol        ','borneol        ',&
'linalool       ','terpineol_4    ','terpineol_a    ','linalool_OXD_c ','linalool_OXD_t ','ionone_b       ',&
'ionone_b       ','bornyl_ACT     ','bornyl_ACT     ','farnescene_a   ','caryophyllene_b','acoradiene     ',&
'aromadendrene  ','bergamotene_a  ','bergamotene_b  ','bisabolene_a   ','bisabolene_b   ','bourbonene_b   ',&
'cadinene_d     ','cadinene_g     ','cedrene_a      ','copaene_a      ','cubebene_a     ','cubebene_b     ',&
'elemene_b      ','farnescene_b   ','germacrene_B   ','germacrene_D   ','gurjunene_b    ','humulene_a     ',&
'humulene_g     ','isolongifolene ','longifolene    ','longipinene    ','muurolene_a    ','muurolene_g    ',&
'selinene_b     ','selinene_d     ','nerolidol_c    ','nerolidol_t    ','cedrol         ','cedrol         ',&
'MBO_2m3e2ol    ','MBO_2m3e2ol    ','methanol       ','acetone        ','methane        ','ammonia        ',&
'nitric_OXD     ','acetaldehyde   ','ethanol        ','formic_acid    ','formaldehyde   ','acetic_acid    ',&
'acetic_acid    ','MBO_3m2e1ol    ','MBO_3m2e1ol    ','MBO_3m3e1ol    ','MBO_3m3e1ol    ','benzaldehyde   ',&
'butanone_2     ','decanal        ','decanal        ','dodecene_1     ','dodecene_1     ','geranyl_acetone',&
'geranyl_acetone','heptanal       ','heptanal       ','heptane        ','hexane         ','met_benzoate   ',&
'met_benzoate   ','met_heptenone  ','met_heptenone  ','neryl_acetone  ','neryl_acetone  ','neryl_acetone  ',&
'nonanal        ','nonanal        ','nonenal        ','nonenal        ','nonenal        ','octanal        ',&
'octanal        ','octanol        ','octenol_1e3ol  ','octenol_1e3ol  ','oxopentanal    ','oxopentanal    ',&
'pentane        ','phenyl_CCO     ','phenyl_CCO     ','pyruvic_acid   ','pyruvic_acid   ','terpinyl_ACT_a ',&
'terpinyl_ACT_a ','tetradecene_1  ','tetradecene_1  ','toluene        ','carbon_monoxide','butene         ',&
'butene         ','ethane         ','ethene         ','propane        ','propene        ','propene        ',&
'diallyl_2s     ','diallyl_2s     ','2met_2s        ','2met_s         ','met_chloride   ','met_bromide    ',&
'met_iodide     ','met_mercaptan  ','met_propenyl_2s','met_propenyl_2s','PPPP_2s        ','PPPP_2s        ',&
'2met_nonatriene','met_salicylate ','met_salicylate ','indole         ','indole         ','jasmone        ',&
'jasmone        ','met_jasmonate  ','met_jasmonate  ','3met_3DCTT     ','hexanal        ','hexanal        ',&
'hexanol_1      ','hexenal_c3     ','hexenal_c3     ','hexenal_t2     ','hexenal_t2     ','hexenol_c3     ',&
'hexenol_c3     ','hexenyl_ACT_c3 ','hexenyl_ACT_c3 ','hexenyl_ACT_c3 ','homosalate     ','homosalate     ',&
'Ehsalate       ','Ehsalate       ','pentanal       ','pentanal       ','heptanone      ','anisole        ',&
'verbenene      ','benzyl-acetate ','benzyl-acetate ','benzyl-acetate ','myrtenal       ','benzyl-alcohol ',&
'meta-cymenene  ','meta-cymenene  ','ipsenol        ','Napthalene     ','Napthalene     ','fenchone       ',&
'thujone_a      ','thujone_b      ','butanone_2     ','met_heptenone  ','neryl_acetone  ','heptanone      '/)

INTEGER, DIMENSION(N_CB6) :: NSPMH_MAP_CB6=(/&    
  1,  2,  3,  4,  5,  6,  7,  8,  9,  9,  9, 10, 10, 11, 11, 12,&
 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 23, 24, 25, 25, 26,&
 26, 27, 28, 28, 29, 29, 30, 30, 31, 31, 32, 33, 34, 35, 36, 37,&
 37, 38, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51,&
 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67,&
 68, 69, 70, 70, 71, 71, 72, 73, 74, 75, 77, 78, 79, 80, 81, 82,&
 82, 83, 83, 84, 84, 85, 86, 87, 87, 88, 88, 89, 89, 90, 90, 91,&
 92, 93, 93, 94, 94, 95, 95, 95, 96, 96, 97, 97, 97, 98, 98, 99,&
100,100,101,101,102,103,103,104,104,105,105,106,106,107,108,109,&
109,110,111,113,114,114,117,117,118,119,120,121,122,124,125,125,&
126,126,127,128,128,129,129,130,130,131,131,132,133,133,134,135,&
135,136,136,137,137,138,138,138,139,139,140,140,141,141,142,143,&
144,145,145,145,146,147,148,148,149,150,150, 26, 28, 29, 86, 94,&
 95,142/)

CHARACTER(LEN=4), DIMENSION(N_CB6) :: CMECH_NAM_CB6=(/&
'ISOP','TERP','TERP','TERP','TERP','TERP','TERP','TERP','PAR ','XYL ','OLE ','PAR ','XYL ','PAR ','XYL ','TERP',&
'TERP','TERP','TERP','TERP','TERP','TERP','TERP','TERP','TERP','TERP','PAR ','NR  ','TERP','PAR ','NR  ','PAR ',&
'NR  ','TERP','PAR ','NR  ','PAR ','NR  ','PAR ','NR  ','PAR ','NR  ','TERP','TERP','TERP','TERP','TERP','TERP',&
'NR  ','PAR ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ',&
'NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ','NR  ',&
'NR  ','NR  ','PAR ','NR  ','OLE ','PAR ','MEOH','ACET','CH4 ','NH3 ','NO  ','ALD2','ETOH','NR  ','FORM','PAR ',&
'NR  ','ALDX','PAR ','FORM','PAR ','TOL ','PAR ','ALDX','PAR ','OLE ','PAR ','TERP','NR  ','ALDX','PAR ','PAR ',&
'PAR ','TOL ','NR  ','PAR ','ALDX','IOLE','PAR ','NR  ','ALDX','PAR ','PAR ','IOLE','ALDX','ALDX','PAR ','PAR ',&
'PAR ','OLE ','PAR ','ALDX','PAR ','TOL ','ALDX','FORM','ALDX','TERP','NR  ','PAR ','OLE ','TOL ','CO  ','OLE ',&
'PAR ','ETHA','ETH ','PRPA','OLE ','PAR ','PAR ','OLE ','PAR ','PAR ','NR  ','NR  ','NR  ','PAR ','PAR ','OLE ',&
'PAR ','OLE ','TERP','TOL ','NR  ','TOL ','NR  ','TERP','NR  ','TERP','NR  ','NR  ','ALDX','PAR ','PAR ','IOLE',&
'ALDX','IOLE','ALDX','PAR ','IOLE','PAR ','IOLE','NR  ','TERP','NR  ','TERP','NR  ','ALDX','PAR ','PAR ','TOL ',&
'TERP','TOL ','PAR ','NR  ','TERP','TOL ','XYL ','PAR ','TERP','XYL ','PAR ','KET ','KET ','KET ','KET ','KET ',&
'KET ','KET '/)

INTEGER, DIMENSION(N_CB6) :: NMECH_MAP_CB6=(/&
 1, 2, 2, 2, 2, 2, 2, 2, 3, 4, 5, 3, 4, 3, 4, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 3, 6, 2, 3, 6, 3,&
 6, 2, 3, 6, 3, 6, 3, 6, 3, 6, 2, 2, 2, 2, 2, 2, 6, 3, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6,&
 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 3, 6, 5, 3, 7,23, 8, 9,10,11,12, 6,13, 3,&
 6,14, 3,13, 3,15, 3,14, 3, 5, 3, 2, 6,14, 3, 3, 3,15, 6, 3,14,16, 3, 6,14, 3, 3,16,14,14, 3, 3,&
 3, 5, 3,14, 3,15,14,13,14, 2, 6, 3, 5,15,17, 5, 3,18,19,21, 5, 3, 3, 5, 3, 3, 6, 6, 6, 3, 3, 5,&
 3, 5, 2,15, 6,15, 6, 2, 6, 2, 6, 6,14, 3, 3,16,14,16,14, 3,16, 3,16, 6, 2, 6, 2, 6,14, 3, 3,15,&
 2,15, 3, 6, 2,15, 4, 3, 2, 4, 3,24,24,24,24,24,24,24/)

REAL, DIMENSION(N_CB6)  :: XCONV_FAC_CB6=(/&
  1.,  1.,  1.,  1.,  1.,  1.,  1.,  1.,  1.,  1., 0.5,  2.,  1.,  2.,  1.,  1.,&
  1.,  1.,  1.,  1.,  1.,  1.,  1.,  1.,  1.,  1.,  9.,  1.,  1.,  8.,  2.,  7.,&
  2.,  1.,  8.,  1.,  8.,  1.,  9.,  1.,  8.,  2.,  1.,  1.,  1.,  1.,  1.,  1.,&
  3.,  6.,  6., 15., 15., 15., 15., 15., 15., 15., 15., 15., 15., 15., 15., 15.,&
 15., 15., 15., 15., 15., 15., 15., 15., 15., 15., 15., 15., 15., 15., 15., 15.,&
 15., 15., 13.,  2.,  1.,  3.,  1.,  1.,  1.,  1.,  1.,  1.,  1.,  1.,  1.,  1.,&
  1.,  1.,  3.,  1.,  4.,  1.,  3.,  1.,  8.,  1., 10.,  1.,  3.,  1.,  5.,  7.,&
  6.,  1.,  1.,  5.,  1.,  1.,  7.,  1.,  1.,  7.,  3.,  1.,  1.,  1.,  6.,  8.,&
  6.,  1.,  3.,  1.,  5.,  1., 0.5,  1.,  1.,  1.,  2., 12.,  1.,  1.,  1.,  1.,&
  2.,  1.,  1.,  1.,  1.,  1.,  2.,  2.,  2.,  2.,  1.,  1.,  1.,  1.,  2.,  1.,&
  4.,  1.,  1.,  1.,  1.,  1.,  1.,  1.,  1.,  1.,  3., 16.,  1.,  4.,  6.,  1.,&
  1.,  1.,  1.,  2.,  1.,  3.,  1.,  1.,  1.,  3.,  1.,  3.,  1.,  3.,  6.,  1.,&
  1.,  1.,  1.,  1.,  1.,  1.,  1.,  2.,  1.,  1.,  2.,  1.,  1.,  1.,  1.,  1.,&
  1.,  1./)


!****************************************************************************************************************
!****************************************************************************************************************

INTEGER, PARAMETER :: N_SAPRCII_SPC = 31  ! Number of mechanism species

CHARACTER(LEN=8), PARAMETER, DIMENSION(N_SAPRCII_SPC) :: CMECH_SPC_SAPRCII=(/&  ! Mechanism species name
'ISOPRENE','TRP1    ','BCARL   ','AHUMUL  ','SSQT    ','MEOH    ','ACET    ','CH4     ',&
'NO      ','NO2     ','NH3     ','CCHO    ','HCOOH   ','HCHO    ','CCO_OH  ','BALD    ',&
'MEK     ','RCO_OH  ','CO      ','ETHENE  ','ALK1    ','ALK2    ','ALK3    ','ALK4    ',&
'ALK5    ','ARO1    ','ARO2    ','OLE1    ','OLE2    ','RCHO    ','NONR    '/)

REAL, PARAMETER, DIMENSION(N_SAPRCII_SPC) :: XMECH_MWT_SAPRCII=(/&  ! Mechanism species mol. wt.
 68.0,136.0,204.0,204.0,204.0, 32.0, 58.0, 16.0, 30.0,44.01, 17.0, 44.0, 46.0, 30.0, 60.0,106.0,&
 72.0, 74.0, 28.0, 28.0, 30.1, 36.7, 58.6, 77.6,118.9, 98.6,118.7, 72.3, 75.8, 58.0,  1.0/)


INTEGER, PARAMETER :: N_SAPRCII = 150        ! Number of map species

CHARACTER(LEN=17), PARAMETER, DIMENSION(N_SAPRCII) :: CSPMH_NAM_SAPRCII=(/&   ! speciated species name
'isoprene         ','myrcene          ','sabinene         ','limonene         ','carene_3         ','ocimene_t_b      ',&
'pinene_b         ','pinene_a         ','A_2met_styrene   ','cymene_p         ','cymene_o         ','phellandrene_a   ',&
'thujene_a        ','terpinene_a      ','terpinene_g      ','terpinolene      ','phellandrene_b   ','camphene         ',&
'bornene          ','fenchene_a       ','ocimene_al       ','ocimene_c_b      ','tricyclene       ','estragole        ',&
'camphor          ','fenchone         ','piperitone       ','thujone_a        ','thujone_b        ','cineole_1_8      ',&
'borneol          ','linalool         ','terpineol_4      ','terpineol_a      ','linalool_OXD_c   ','linalool_OXD_t   ',&
'ionone_b         ','bornyl_ACT       ','farnescene_a     ','caryophyllene_b  ','acoradiene       ','aromadendrene    ',&
'bergamotene_a    ','bergamotene_b    ','bisabolene_a     ','bisabolene_b     ','bourbonene_b     ','cadinene_d       ',&
'cadinene_g       ','cedrene_a        ','copaene_a        ','cubebene_a       ','cubebene_b       ','elemene_b        ',&
'farnescene_b     ','germacrene_B     ','germacrene_D     ','gurjunene_b      ','humulene_a       ','humulene_g       ',&
'isolongifolene   ','longifolene      ','longipinene      ','muurolene_a      ','muurolene_g      ','selinene_b       ',&
'selinene_d       ','nerolidol_c      ','nerolidol_t      ','cedrol           ','MBO_2m3e2ol      ','methanol         ',&
'acetone          ','methane          ','ammonia          ','nitrous_OXD      ','nitric_OXD       ','acetaldehyde     ',&
'ethanol          ','formic_acid      ','formaldehyde     ','acetic_acid      ','MBO_3m2e1ol      ','MBO_3m3e1ol      ',&
'benzaldehyde     ','butanone_2       ','decanal          ','dodecene_1       ','geranyl_acetone  ','heptanal         ',&
'heptane          ','hexane           ','met_benzoate     ','met_heptenone    ','neryl_acetone    ','nonanal          ',&
'nonenal          ','octanal          ','octanol          ','octenol_1e3ol    ','oxopentanal      ','pentane          ',&
'phenyl_CCO       ','pyruvic_acid     ','terpinyl_ACT_a   ','tetradecene_1    ','toluene          ','carbon_monoxide  ',&
'butene           ','ethane           ','ethene           ','hydrogen_cyanide ','propane          ','propene          ',&
'carbon_2s        ','carbonyl_s       ','diallyl_2s       ','A_2met_2s        ','A_2met_s         ','met_chloride     ',&
'met_bromide      ','met_iodide       ','hydrogen_s       ','met_mercaptan    ','met_propenyl_2s  ','PPPP_2s          ',&
'A_2met_nonatriene','met_salicylate   ','indole           ','jasmone          ','met_jasmonate    ','A_3met_3DCTT     ',&
'hexanal          ','hexanol_1        ','hexenal_c3       ','hexenal_t2       ','hexenol_c3       ','hexenyl_ACT_c3   ',&
'homosalate       ','Ehsalate         ','pentanal         ','heptanone        ','anisole          ','verbenene        ',&
'benzyl-acetate   ','myrtenal         ','benzyl-alcohol   ','meta-cymenene    ','ipsenol          ','Napthalene       '/)

INTEGER, PARAMETER, DIMENSION(N_SAPRCII) :: NSPMH_MAP_SAPRCII=(/&   ! speciated species name
  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16,&
 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32,&
 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48,&
 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64,&
 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80,&
 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96,&
 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111,112,&
113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,&
129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,&
145,146,147,148,149,150/)

CHARACTER(LEN=8), PARAMETER, DIMENSION(N_SAPRCII) :: CMECH_NAM_SAPRCII=(/&   ! mechanism species
'ISOPRENE','TRP1g   ','TRP1g   ','TRP1g   ','TRP1g   ','TRP1g   ','TRP1g   ','TRP1g   ',&
'OLE2g   ','ARO2g   ','ARO2g   ','TRP1g   ','TRP1g   ','TRP1g   ','TRP1g   ','TRP1g   ',&
'TRP1g   ','TRP1g   ','TRP1g   ','TRP1g   ','TRP1g   ','TRP1g   ','ALK5g   ','TRP1g   ',&
'TRP1g   ','ALK5g   ','TRP1g   ','ALK5g   ','ALK5g   ','ALK5g   ','ALK5g   ','TRP1g   ',&
'TRP1g   ','TRP1g   ','TRP1g   ','TRP1g   ','SSQTg   ','ALK5g   ','AHUMULg ','BCARLg  ',&
'SSQTg   ','SSQTg   ','SSQTg   ','SSQTg   ','AHUMULg ','SSQTg   ','SSQTg   ','SSQTg   ',&
'SSQTg   ','SSQTg   ','SSQTg   ','SSQTg   ','SSQTg   ','SSQTg   ','AHUMULg ','AHUMULg ',&
'SSQTg   ','SSQTg   ','AHUMULg ','AHUMULg ','SSQTg   ','SSQTg   ','SSQTg   ','SSQTg   ',&
'SSQTg   ','SSQTg   ','SSQTg   ','SSQTg   ','SSQTg   ','ALK5g   ','ISOPRENE','MEOHg   ',&
'ACETg   ','CH4g    ','NH3g    ','NONRg   ','NOg     ','CCHOg   ','ALK3g   ','HCOOHg  ',&
'HCHOg   ','CCO_OHg ','ISOPRENE','ISOPRENE','BALDg   ','MEKg    ','RCHOg   ','OLE1g   ',&
'SSQTg   ','RCHOg   ','ALK5g   ','ALK4g   ','ARO1g   ','OLE2g   ','OLE2g   ','RCHOg   ',&
'OLE1g   ','RCHOg   ','ALK5g   ','OLE1g   ','RCHOg   ','ALK4g   ','ARO1g   ','RCO_OHg ',&
'TRP1g   ','OLE1g   ','ARO1g   ','COg     ','OLE1g   ','ALK1g   ','ETHENEg ','NONRg   ',&
'ALK2g   ','OLE1g   ','NONRg   ','NONRg   ','OLE1g   ','ALK5g   ','ALK4g   ','NONRg   ',&
'NONRg   ','NONRg   ','NONRg   ','ALK5g   ','OLE1g   ','OLE1g   ','TRP1g   ','ARO1g   ',&
'ARO2g   ','TRP1g   ','SSQTg   ','AHUMULg ','RCHOg   ','ALK5g   ','OLE2g   ','OLE2g   ',&
'OLE2g   ','OLE2g   ','SSQTg   ','SSQTg   ','RCHOg   ','OLE2g   ','BALD    ','ARO2g   ',&
'BALDg   ','TRP1g   ','BALDg   ','ARO2g   ','TRP1g   ','ARO2g   '/)

INTEGER, PARAMETER, DIMENSION(N_SAPRCII) :: NMECH_MAP_SAPRCII=(/&   ! mechanism species mapped
 1, 2, 2, 2, 2, 2, 2, 2,29,27,27, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,25, 2, 2,25, 2,25,25,25,25, 2,&
 2, 2, 2, 2, 5,25, 4, 3, 5, 5, 5, 5, 4, 5, 5, 5, 5, 5, 5, 5, 5, 5, 4, 4, 5, 5, 4, 4, 5, 5, 5, 5,&
 5, 5, 5, 5, 5,25, 1, 6, 7, 8,11,31, 9,12,23,13,14,15, 1, 1,16,17,30,28, 5,30,25,24,26,29,29,30,&
28,30,25,28,30,24,26,18, 2,28,26,19,28,21,20,31,22,28,31,31,28,25,24,31,31,31,31,25,28,28, 2,26,&
27, 2, 5, 4,30,25,29,29,29,29, 5, 5,30,29,16,27,16, 2,16,27, 2,27/)

                            ! to SPC_SAPRCII.EXT
REAL, PARAMETER, DIMENSION(N_SAPRCII) :: XCONV_FAC_SAPRCII=(/&   ! conversion factor
1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,&
1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,&
1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,&
1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,&
1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1./)

!****************************************************************************************************************
!****************************************************************************************************************

INTEGER, PARAMETER :: N_RADM2_SPC = 21    ! Number of mechanism species

CHARACTER(LEN=4), PARAMETER, DIMENSION(N_RADM2_SPC) :: CMECH_SPC_RADM2=(/&  ! Mechanism species name
'ISO ','CH4 ','ETH ','HC3 ','HC5 ','HC8 ','OL2 ','OLI ','OLT ','ALD ',&
'KET ','TOL ','HCHO','ORA1','ORA2','CO  ','SO2 ','NO  ','HNO3','NO2 ',&
'NR  '/)

REAL, PARAMETER, DIMENSION(N_RADM2_SPC) ::  XMECH_MWT_RADM2=(/&  ! Mechanism species mol. wt.
  68.,  16.,  30.,  44.,  72., 114.,  28.,  56.,  42.,  44.,  72.,  92.,  30.,  46.,  60.,  28.,&
  64.,  30.,  63.,  46.,   1./)

INTEGER,PARAMETER :: N_RADM2 = 177        ! Number of map species

CHARACTER(LEN=17), PARAMETER, DIMENSION(N_RADM2) :: CSPMH_NAM_RADM2=(/&   ! speciated species name
'isoprene         ','myrcene          ','A_myrcene        ','sabinene         ','limonene         ','A_limonene       ',&
'carene_3         ','ocimene_t_b      ','ocimene_t_b      ','pinene_b         ','pinene_a         ','A_2met_styrene   ',&
'cymene_p         ','cymene_o         ','phellandrene_a   ','thujene_a        ','terpinene_a      ','terpinene_g      ',&
'terpinolene      ','phellandrene_b   ','phellandrene_b   ','camphene         ','bornene          ','fenchene_a       ',&
'ocimene_al       ','ocimene_c_b      ','ocimene_c_b      ','tricyclene       ','estragole        ','camphor          ',&
'fenchone         ','piperitone       ','thujone_a        ','thujone_b        ','cineole_1_8      ','borneol          ',&
'linalool         ','linalool         ','terpineol_4      ','terpineol_a      ','linalool_OXD_c   ','linalool_OXD_t   ',&
'ionone_b         ','bornyl_ACT       ','farnescene_a     ','farnescene_a     ','caryophyllene_b  ','caryophyllene_b  ',&
'acoradiene       ','acoradiene       ','aromadendrene    ','bergamotene_a    ','bergamotene_b    ','bergamotene_b    ',&
'bisabolene_a     ','bisabolene_b     ','bisabolene_b     ','bourbonene_b     ','cadinene_d       ','cadinene_g       ',&
'cadinene_g       ','cedrene_a        ','copaene_a        ','cubebene_a       ','cubebene_b       ','elemene_b        ',&
'farnescene_b     ','farnescene_b     ','germacrene_B     ','germacrene_D     ','germacrene_D     ','gurjunene_b      ',&
'humulene_a       ','humulene_g       ','isolongifolene   ','longifolene      ','longipinene      ','muurolene_a      ',&
'muurolene_g      ','muurolene_g      ','selinene_b       ','selinene_d       ','nerolidol_c      ','nerolidol_c      ',&
'nerolidol_t      ','nerolidol_t      ','cedrol           ','MBO_2m3e2ol      ','methanol         ','acetone          ',&
'methane          ','ammonia          ','nitrous_OXD      ','nitric_OXD       ','acetaldehyde     ','ethanol          ',&
'formic_acid      ','formaldehyde     ','acetic_acid      ','MBO_3m2e1ol      ','MBO_3m3e1ol      ','benzaldehyde     ',&
'butanone_2       ','decanal          ','dodecene_1       ','geranyl_acetone  ','heptanal         ','heptane          ',&
'hexane           ','met_benzoate     ','met_heptenone    ','neryl_acetone    ','nonanal          ','nonenal          ',&
'nonenal          ','octanal          ','octanol          ','octenol_1e3ol    ','oxopentanal      ','pentane          ',&
'phenyl_CCO       ','pyruvic_acid     ','terpinyl_ACT_a   ','tetradecene_1    ','toluene          ','carbon_monoxide  ',&
'butene           ','ethane           ','ethene           ','hydrogen_cyanide ','propane          ','propene          ',&
'carbon_2s        ','carbonyl_s       ','diallyl_2s       ','diallyl_2s       ','A_2met_2s        ','A_2met_2s        ',&
'A_2met_s         ','A_2met_s         ','met_chloride     ','met_bromide      ','met_iodide       ','hydrogen_s       ',&
'met_mercaptan    ','met_mercaptan    ','met_propenyl_2s  ','met_propenyl_2s  ','PPPP_2s          ','PPPP_2s          ',&
'A_2met_nonatriene','A_2met_nonatriene','met_salicylate   ','indole           ','indole           ','jasmone          ',&
'met_jasmonate    ','A_3met_3DCTT     ','A_3met_3DCTT     ','hexanal          ','hexanol_1        ','hexenal_c3       ',&
'hexenal_t2       ','hexenol_c3       ','hexenyl_ACT_c3   ','homosalate       ','Ehsalate         ','pentanal         ',&
'heptanone        ','anisole          ','verbenene        ','benzyl-acetate   ','myrtenal         ','benzyl-alcohol   ',&
'meta-cymenene    ','ipsenol          ','Napthalene       '/)

INTEGER, PARAMETER, DIMENSION(N_RADM2) :: NSPMH_MAP_RADM2=(/&   ! speciated species name
  1,  2,  2,  3,  4,  4,  5,  6,  6,  7,  8,  9, 10, 11, 12, 13,&
 14, 15, 16, 17, 17, 18, 19, 20, 21, 22, 22, 23, 24, 25, 26, 27,&
 28, 29, 30, 31, 32, 32, 33, 34, 35, 36, 37, 38, 39, 39, 40, 40,&
 41, 41, 42, 43, 44, 44, 45, 46, 46, 47, 48, 49, 49, 50, 51, 52,&
 53, 54, 55, 55, 56, 57, 57, 58, 59, 60, 61, 62, 63, 64, 65, 65,&
 66, 67, 68, 68, 69, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79,&
 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95,&
 96, 97, 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,&
111,112,113,114,115,116,117,117,118,118,119,119,120,121,122,123,&
124,124,125,125,126,126,127,127,128,129,129,130,131,132,132,133,&
134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,&
150/)

                            ! mapped to SPC_SPCAT.EXT
CHARACTER(LEN=4), PARAMETER, DIMENSION(N_RADM2) :: CMECH_NAM_RADM2=(/&   ! mechanism species
'ISO ','OLT ','OLI ','OLT ','OLT ','OLI ','OLI ','OLT ','OLI ','OLT ','OLI ','TOL ','TOL ','TOL ','OLI ','OLI ',&
'OLI ','OLI ','OLI ','OLT ','OLI ','OLT ','OLI ','OLT ','OLI ','OLT ','OLI ','NR  ','OLT ','HC8 ','NR  ','OLT ',&
'NR  ','NR  ','HC8 ','NR  ','OLT ','OLI ','OLI ','OLI ','OLT ','OLT ','OLI ','NR  ','OLT ','OLI ','OLT ','OLI ',&
'OLT ','OLI ','OLT ','OLI ','OLT ','OLI ','OLI ','OLT ','OLI ','OLT ','OLI ','OLT ','OLI ','OLI ','OLI ','OLI ',&
'OLT ','OLT ','OLT ','OLI ','OLI ','OLT ','OLI ','OLI ','OLI ','OLI ','OLI ','OLT ','OLI ','OLI ','OLT ','OLI ',&
'OLT ','OLI ','OLT ','OLI ','OLT ','OLI ','NR  ','ISO ','HC3 ','KET ','CH4 ','NR  ','NO2 ','NO  ','ALD ','HC3 ',&
'ORA1','HCHO','ORA2','ISO ','ISO ','NR  ','KET ','ALD ','OLT ','OLI ','ALD ','HC5 ','HC5 ','HC8 ','OLI ','OLI ',&
'ALD ','ALD ','HC8 ','ALD ','HC8 ','OLT ','ALD ','HC5 ','NR  ','ORA2','OLI ','OLT ','TOL ','CO  ','OLT ','ETH ',&
'OL2 ','NR  ','HC3 ','OLT ','NR  ','NR  ','OLI ','SO2 ','ETH ','SO2 ','ETH ','SO2 ','NR  ','NR  ','NR  ','SO2 ',&
'CH4 ','SO2 ','OLI ','SO2 ','OLI ','SO2 ','OLT ','OLI ','HC8 ','HC8 ','HNO3','OLI ','OLI ','OLT ','OLI ','ALD ',&
'HC5 ','OLI ','OLI ','OLT ','OLI ','OLI ','OLI ','ALD ','OLI ','NR  ','TOL ','NR  ','OLT ','NR  ','TOL ','OLT ',&
'HC8 '/)

INTEGER, PARAMETER, DIMENSION(N_RADM2) :: NMECH_MAP_RADM2=(/&   ! mechanism species mapped
 1, 9, 8, 9, 9, 8, 8, 9, 8, 9, 8,12,12,12, 8, 8, 8, 8, 8, 9, 8, 9, 8, 9, 8, 9, 8,21, 9, 6,21, 9,&
21,21, 6,21, 9, 8, 8, 8, 9, 9, 8,21, 9, 8, 9, 8, 9, 8, 9, 8, 9, 8, 8, 9, 8, 9, 8, 9, 8, 8, 8, 8,&
 9, 9, 9, 8, 8, 9, 8, 8, 8, 8, 8, 9, 8, 8, 9, 8, 9, 8, 9, 8, 9, 8,21, 1, 4,11, 2,21,20,18,10, 4,&
14,13,15, 1, 1,21,11,10, 9, 8,10, 5, 5, 6, 8, 8,10,10, 6,10, 6, 9,10, 5,21,15, 8, 9,12,16, 9, 3,&
 7,21, 4, 9,21,21, 8,17, 3,17, 3,17,21,21,21,17, 2,17, 8,17, 8,17, 9, 8, 6, 6,19, 8, 8, 9, 8,10,&
 5, 8, 8, 9, 8, 8, 8,10, 8,21,12,21, 9,21,12, 9, 6/)

                            ! to SPC_RADM2.EXT
REAL, PARAMETER, DIMENSION(N_RADM2) :: XCONV_FAC_RADM2=(/&   ! conversion factor
   1.,  0.5,  0.5,   1.,  0.5,  0.5,   1.,  0.5,  0.5,   1.,   1.,   1.,   1.,   1.,   1.,   1.,&
   1.,   1.,   1.,  0.5,  0.5,   1.,   1.,   1.,   1.,  0.5,  0.5,   1.,   1.,0.388,   1.,   1.,&
   1.,   1.,0.755,   1.,  0.5,  0.5,   1.,   1.,   1.,   1.,   1.,   1.,  0.5,  0.5,  0.5,  0.5,&
  0.5,  0.5,   1.,   1.,  0.5,  0.5,   1.,  0.5,  0.5,   1.,   1.,  0.5,  0.5,   1.,   1.,   1.,&
   1.,   1.,  0.5,  0.5,   1.,  0.5,  0.5,   1.,   1.,   1.,   1.,   1.,   1.,   1.,  0.5,  0.5,&
   1.,   1.,  0.5,  0.5,  0.5,  0.5,   1.,   1.,0.402,0.253,   1.,   1.,   1.,   1.,   1.,1.198,&
   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,1.226,1.049,   1.,   1.,   1.,&
   1.,   1.,   1.,   1.,1.119,   1.,   1.,0.847,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,&
   1.,   1.,0.519,   1.,   1.,   1.,   1.,   2.,   1.,   2.,   1.,   1.,   1.,   1.,   1.,   1.,&
   1.,   1.,   1.,   2.,   1.,   2.,  0.5,  0.5,   1.,1.238,   1.,   1.,   1.,  0.5,  0.5,   1.,&
1.697,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,&
   1./)

!****************************************************************************************************************
!****************************************************************************************************************

   INTEGER, PARAMETER :: N_RACM_SPC = 23     ! Number of mechanism species

CHARACTER(LEN=4), PARAMETER, DIMENSION(N_RACM_SPC) :: CMECH_SPC_RACM=(/&  ! Mechanism species name
'ISO ','CH4 ','ETH ','HC3 ','HC5 ','HC8 ','OL2 ','OLI ','OLT ','ALD ','KET ','TOL ','HCHO','ORA1','ORA2','API ',&
'LIM ','CO  ','SO2 ','NO  ','HNO3','NO2 ','NR  '/)

REAL, PARAMETER, DIMENSION(N_RACM_SPC) :: XMECH_MWT_RACM=(/&  ! Mechanism species mol. wt.
  68.,  16.,  30.,  44.,  72., 114.,  28.,  68.,  42.,  44.,  72.,  92.,  30.,  46.,  60., 136.,&
 136.,  28.,  64.,  30.,  63.,  46.,   1./)

INTEGER, PARAMETER :: N_RACM = 159        ! Number of map species

CHARACTER(LEN=17), PARAMETER, DIMENSION(N_RACM) :: CSPMH_NAM_RACM=(/&   ! speciated species name
'isoprene         ','myrcene          ','sabinene         ','limonene         ','carene_3         ','ocimene_t_b      ',&
'pinene_b         ','pinene_a         ','A_2met_styrene   ','cymene_p         ','cymene_o         ','phellandrene_a   ',&
'thujene_a        ','terpinene_a      ','terpinene_g      ','terpinolene      ','phellandrene_b   ','camphene         ',&
'bornene          ','fenchene_a       ','ocimene_al       ','ocimene_c_b      ','tricyclene       ','estragole        ',&
'camphor          ','fenchone         ','piperitone       ','thujone_a        ','thujone_b        ','cineole_1_8      ',&
'borneol          ','linalool         ','terpineol_4      ','terpineol_a      ','linalool_OXD_c   ','linalool_OXD_t   ',&
'ionone_b         ','bornyl_ACT       ','farnescene_a     ','caryophyllene_b  ','acoradiene       ','aromadendrene    ',&
'bergamotene_a    ','bergamotene_b    ','bisabolene_a     ','bisabolene_b     ','bourbonene_b     ','cadinene_d       ',&
'cadinene_g       ','cedrene_a        ','copaene_a        ','cubebene_a       ','cubebene_b       ','elemene_b        ',&
'farnescene_b     ','germacrene_B     ','germacrene_D     ','gurjunene_b      ','humulene_a       ','humulene_g       ',&
'isolongifolene   ','longifolene      ','longipinene      ','muurolene_a      ','muurolene_g      ','selinene_b       ',&
'selinene_d       ','nerolidol_c      ','nerolidol_t      ','cedrol           ','MBO_2m3e2ol      ','methanol         ',&
'acetone          ','methane          ','ammonia          ','nitrous_OXD      ','nitric_OXD       ','acetaldehyde     ',&
'ethanol          ','formic_acid      ','formaldehyde     ','acetic_acid      ','MBO_3m2e1ol      ','MBO_3m3e1ol      ',&
'benzaldehyde     ','butanone_2       ','decanal          ','dodecene_1       ','geranyl_acetone  ','heptanal         ',&
'heptane          ','hexane           ','met_benzoate     ','met_heptenone    ','neryl_acetone    ','nonanal          ',&
'nonenal          ','nonenal          ','octanal          ','octanol          ','octenol_1e3ol    ','oxopentanal      ',&
'pentane          ','phenyl_CCO       ','pyruvic_acid     ','terpinyl_ACT_a   ','tetradecene_1    ','toluene          ',&
'carbon_monoxide  ','butene           ','ethane           ','ethene           ','hydrogen_cyanide ','propane          ',&
'propene          ','carbon_2s        ','carbonyl_s       ','diallyl_2s       ','diallyl_2s       ','A_2met_2s        ',&
'A_2met_2s        ','A_2met_s         ','A_2met_s         ','met_chloride     ','met_bromide      ','met_iodide       ',&
'hydrogen_s       ','met_mercaptan    ','met_mercaptan    ','met_propenyl_2s  ','met_propenyl_2s  ','PPPP_2s          ',&
'PPPP_2s          ','A_2met_nonatriene','met_salicylate   ','indole           ','indole           ','jasmone          ',&
'met_jasmonate    ','A_3met_3DCTT     ','A_3met_3DCTT     ','hexanal          ','hexanol_1        ','hexenal_c3       ',&
'hexenal_t2       ','hexenol_c3       ','hexenyl_ACT_c3   ','homosalate       ','Ehsalate         ','pentanal         ',&
'heptanone        ','anisole          ','verbenene        ','benzyl-acetate   ','myrtenal         ','benzyl-alcohol   ',&
'meta-cymenene    ','ipsenol          ','Napthalene       '/)


INTEGER, PARAMETER, DIMENSION(N_RACM) :: NSPMH_MAP_RACM=(/&   ! speciated species name
  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16,&
 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32,&
 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48,&
 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64,&
 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80,&
 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96,&
 97, 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111,&
112,113,114,115,116,117,117,118,118,119,119,120,121,122,123,124,&
124,125,125,126,126,127,128,129,129,130,131,132,132,133,134,135,&
136,137,138,139,140,141,142,143,144,145,146,147,148,149,150/)

                            ! mapped to SPC_SPCAT.EXT
CHARACTER(LEN=4), PARAMETER, DIMENSION(N_RACM) :: CMECH_NAM_RACM=(/&   ! mechanism species
'ISO ','LIM ','API ','LIM ','API ','LIM ','API ','API ','LIM ','LIM ','LIM ','LIM ','API ','LIM ','LIM ','LIM ',&
'LIM ','API ','API ','API ','LIM ','LIM ','NR  ','LIM ','HC8 ','NR  ','API ','NR  ','NR  ','HC8 ','NR  ','LIM ',&
'API ','API ','LIM ','LIM ','LIM ','NR  ','LIM ','LIM ','LIM ','API ','LIM ','LIM ','LIM ','LIM ','API ','LIM ',&
'LIM ','API ','API ','API ','API ','LIM ','LIM ','LIM ','LIM ','API ','LIM ','LIM ','API ','API ','API ','LIM ',&
'LIM ','LIM ','LIM ','LIM ','LIM ','NR  ','ISO ','HC3 ','KET ','CH4 ','NR  ','NO2 ','NO  ','ALD ','HC3 ','ORA1',&
'HCHO','ORA2','ISO ','ISO ','NR  ','KET ','ALD ','OLT ','LIM ','ALD ','HC5 ','HC5 ','HC8 ','OLI ','OLI ','ALD ',&
'HC8 ','ALD ','ALD ','HC8 ','OLT ','ALD ','HC5 ','NR  ','ORA2','API ','OLT ','TOL ','CO  ','OLT ','ETH ','ETE ',&
'NR  ','HC3 ','OLT ','NR  ','NR  ','OLI ','SO2 ','ETH ','SO2 ','ETH ','SO2 ','NR  ','NR  ','NR  ','SO2 ','CH4 ',&
'SO2 ','OLI ','SO2 ','OLI ','SO2 ','LIM ','HC8 ','HC8 ','HNO3','LIM ','LIM ','OLI ','OLT ','ALD ','HC5 ','OLI ',&
'OLI ','OLT ','OLI ','LIM ','LIM ','ALD ','OLI ','NR  ','LIM ','NR  ','LIM ','NR  ','LIM ','LIM ','HC8 '/)

INTEGER, PARAMETER, DIMENSION(N_RACM) :: NMECH_MAP_RACM=(/&   ! mechanism species mapped
 1,17,16,17,16,17,16,16,17,17,17,17,16,17,17,17,17,16,16,16,17,17,23,17, 6,23,16,23,23, 6,23,17,&
16,16,17,17,17,23,17,17,17,16,17,17,17,17,16,17,17,16,16,16,16,17,17,17,17,16,17,17,16,16,16,17,&
17,17,17,17,17,23, 1, 4,11, 2,23,22,20,10, 4,14,13,15, 1, 1,23,11,10, 9,17,10, 5, 5, 6, 8, 8,10,&
 6,10,10, 6, 9,10, 5,23,15,16, 9,12,18, 9, 3, 7,23, 4, 9,23,23, 8,19, 3,19, 3,19,23,23,23,19, 2,&
19, 8,19, 8,19,17, 6, 6,21,17,17, 8, 9,10, 5, 8, 8, 9, 8,17,17,10, 8,23,17,23,17,23,17,17, 6/)

                            ! to SPC_RACM.EXT
REAL, PARAMETER, DIMENSION(N_RACM) :: XCONV_FAC_RACM=(/&   ! conversion factor
   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,&
   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1., 0.38,   1.,   1.,   1.,   1.,0.738,   1.,   1.,&
   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,&
   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,&
   1.,   1.,   1.,   1.,   1.,   1.,   1., 0.49, 0.33,   1.,   1.,   1.,   1.,   1., 1.37,   1.,&
   1.,   1.,   1.,   1.,   1., 1.61,   1.,   1.,   1.,   1.,1.236,1.058,   1.,   1.,   1.,   1.,&
   1.,   1.,   1.,1.092,   1.,   1.,0.854,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,&
   1., 0.57,   1.,   1.,   1.,   1.,   2.,   1.,   2.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,&
   1.,   1.,   2.,   1.,   2.,   1.,   1.,1.201,   1.,   1.,   1.,  0.5,  0.5,   1., 1.71,   1.,&
   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1.,   1./)


!****************************************************************************************************************
!****************************************************************************************************************

INTEGER, PARAMETER :: N_CBMZ_SPC = 23     ! Number of mechanism species

CHARACTER(LEN=5), PARAMETER, DIMENSION(N_CBMZ_SPC) :: CMECH_SPC_CBMZ=(/&  ! Mechanism species name
'ISOP ','NO   ','NO2  ','CO   ','CH3OH','ANOL ','ALD2 ','HCHO ','HCOOH','RCOOH','CH4  ','C2H6 ','PAR  ','ETH  ','OLET ','OLEI ',&
'CRES ','AONE ','TOL  ','XYL  ','DMS  ','NH3  ','NR   '/)

REAL, PARAMETER, DIMENSION(N_CBMZ_SPC) :: XMECH_MWT_CBMZ=(/&  ! Mechanism species mol. wt.
 68.12, 30.01, 44.01, 28.01, 32.04, 46.07, 44.05, 30.03, 46.03, 60.05, 16.04, 30.07, 13.00, 28.05, 27.00, 26.00,&
108.14, 58.08, 92.14,106.17, 62.14, 17.03,  1.00/)

INTEGER, PARAMETER :: N_CBMZ = 185        ! Number of map species

CHARACTER(LEN=17), PARAMETER, DIMENSION(N_CBMZ) :: CSPMH_NAM_CBMZ=(/&   ! speciated species name
'isoprene         ','myrcene          ','sabinene         ','limonene         ','carene_3         ','ocimene_t_b      ',&
'pinene_b         ','pinene_a         ','A_2met_styrene   ','cymene_p         ','cymene_o         ','phellandrene_a   ',&
'thujene_a        ','terpinene_a      ','terpinene_g      ','terpinolene      ','phellandrene_b   ','camphene         ',&
'bornene          ','fenchene_a       ','ocimene_al       ','ocimene_c_b      ','tricyclene       ','estragole        ',&
'camphor          ','fenchone         ','piperitone       ','thujone_a        ','thujone_b        ','cineole_1_8      ',&
'borneol          ','linalool         ','terpineol_4      ','terpineol_a      ','linalool_OXD_c   ','linalool_OXD_t   ',&
'ionone_b         ','bornyl_ACT       ','farnescene_a     ','caryophyllene_b  ','acoradiene       ','aromadendrene    ',&
'bergamotene_a    ','bergamotene_b    ','bisabolene_a     ','bisabolene_b     ','bourbonene_b     ','cadinene_d       ',&
'cadinene_g       ','cedrene_a        ','copaene_a        ','cubebene_a       ','cubebene_b       ','elemene_b        ',&
'farnescene_b     ','germacrene_B     ','germacrene_D     ','gurjunene_b      ','humulene_a       ','humulene_g       ',&
'isolongifolene   ','longifolene      ','longipinene      ','muurolene_a      ','muurolene_g      ','selinene_b       ',&
'selinene_d       ','nerolidol_c      ','nerolidol_t      ','cedrol           ','MBO_2m3e2ol      ','MBO_2m3e2ol      ',&
'methanol         ','acetone          ','methane          ','ammonia          ','nitrous_OXD      ','nitric_OXD       ',&
'acetaldehyde     ','ethanol          ','formic_acid      ','formaldehyde     ','acetic_acid      ','MBO_3m2e1ol      ',&
'MBO_3m2e1ol      ','MBO_3m3e1ol      ','MBO_3m3e1ol      ','benzaldehyde     ','butanone_2       ','butanone_2       ',&
'decanal          ','decanal          ','dodecene_1       ','dodecene_1       ','geranyl_acetone  ','heptanal         ',&
'heptanal         ','heptane          ','hexane           ','met_benzoate     ','met_heptenone    ','met_heptenone    ',&
'met_heptenone    ','neryl_acetone    ','neryl_acetone    ','neryl_acetone    ','nonanal          ','nonanal          ',&
'nonenal          ','nonenal          ','nonenal          ','octanal          ','octanal          ','octanol          ',&
'octenol_1e3ol    ','octenol_1e3ol    ','oxopentanal      ','oxopentanal      ','pentane          ','phenyl_CCO       ',&
'phenyl_CCO       ','pyruvic_acid     ','pyruvic_acid     ','terpinyl_ACT_a   ','tetradecene_1    ','tetradecene_1    ',&
'toluene          ','carbon_monoxide  ','butene           ','butene           ','ethane           ','ethene           ',&
'hydrogen_cyanide ','propane          ','propene          ','propene          ','carbon_2s        ','carbonyl_s       ',&
'diallyl_2s       ','diallyl_2s       ','diallyl_2s       ','A_2met_2s        ','A_2met_s         ','met_chloride     ',&
'met_bromide      ','met_iodide       ','hydrogen_s       ','met_mercaptan    ','met_propenyl_2s  ','met_propenyl_2s  ',&
'PPPP_2s          ','PPPP_2s          ','PPPP_2s          ','A_2met_nonatriene','met_salicylate   ','indole           ',&
'jasmone          ','met_jasmonate    ','A_3met_3DCTT     ','hexanal          ','hexanal          ','hexanol_1        ',&
'hexenal_c3       ','hexenal_c3       ','hexenal_c3       ','hexenal_t2       ','hexenal_t2       ','hexenal_t2       ',&
'hexenol_c3       ','hexenol_c3       ','hexenyl_ACT_c3   ','hexenyl_ACT_c3   ','hexenyl_ACT_c3   ','homosalate       ',&
'Ehsalate         ','pentanal         ','heptanone        ','anisole          ','verbenene        ','benzyl-acetate   ',&
'myrtenal         ','benzyl-alcohol   ','meta-cymenene    ','ipsenol          ','Napthalene       '/)

INTEGER, PARAMETER, DIMENSION(N_CBMZ) :: NSPMH_MAP_CBMZ=(/&   ! speciated species name
  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16,&
 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32,&
 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48,&
 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64,&
 65, 66, 67, 68, 69, 70, 71, 71, 72, 73, 74, 75, 76, 77, 78, 79,&
 80, 81, 82, 83, 83, 84, 84, 85, 86, 86, 87, 87, 88, 88, 89, 90,&
 90, 91, 92, 93, 94, 94, 94, 95, 95, 95, 96, 96, 97, 97, 97, 98,&
 98, 99,100,100,101,101,102,103,103,104,104,105,106,106,107,108,&
109,109,110,111,112,113,114,114,115,116,117,117,117,118,119,120,&
121,122,123,124,125,125,126,126,126,127,128,129,130,131,132,133,&
133,134,135,135,135,136,136,136,137,137,138,138,138,139,140,141,&
142,143,144,145,146,147,148,149,150/)

                            ! mapped to SPC_SPCAT.EXT
CHARACTER(LEN=5), PARAMETER, DIMENSION(N_CBMZ) :: CMECH_NAM_CBMZ=(/&   ! mechanism species
'ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ',&
'ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ',&
'ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ',&
'ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ',&
'ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','ISOP ','OLET ','PAR  ','CH3OH','AONE ','CH4  ','NH3  ','NR   ','NO   ','ALD2 ','ANOL ',&
'HCOOH','HCHO ','RCOOH','ALD2 ','PAR  ','HCHO ','PAR  ','TOL  ','AONE ','PAR  ','ALD2 ','PAR  ','OLET ','PAR  ','ISOP ','ALD2 ',&
'PAR  ','PAR  ','PAR  ','TOL  ','AONE ','PAR  ','OLET ','AONE ','PAR  ','OLEI ','ALD2 ','PAR  ','ALD2 ','PAR  ','OLEI ','ALD2 ',&
'PAR  ','PAR  ','PAR  ','OLET ','PAR  ','ALD2 ','PAR  ','ALD2 ','TOL  ','HCOOH','AONE ','ISOP ','PAR  ','OLET ','TOL  ','CO   ',&
'OLET ','PAR  ','C2H6 ','ETH  ','NR   ','PAR  ','OLET ','PAR  ','NR   ','NR   ','DMS  ','PAR  ','OLET ','DMS  ','DMS  ','NR   ',&
'NR   ','NR   ','NR   ','PAR  ','DMS  ','OLEI ','DMS  ','PAR  ','OLEI ','ISOP ','TOL  ','TOL  ','ISOP ','ISOP ','ISOP ','ALD2 ',&
'PAR  ','PAR  ','ALD2 ','PAR  ','OLEI ','ALD2 ','PAR  ','OLEI ','PAR  ','OLEI ','AONE ','PAR  ','OLEI ','ISOP ','ISOP ','ALD2 ',&
'AONE ','TOL  ','ISOP ','TOL  ','ISOP ','TOL  ','ISOP ','ISOP ','TOL  '/)

INTEGER, PARAMETER, DIMENSION(N_CBMZ) :: NMECH_MAP_CBMZ=(/&   ! mechanism species mapped
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,&
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,&
 1, 1, 1, 1, 1, 1,15,13, 5,18,11,22,23, 2, 7, 6, 9, 8,10, 7,13, 8,13,19,18,13, 7,13,15,13, 1, 7,&
13,13,13,19,18,13,15,18,13,16, 7,13, 7,13,16, 7,13,13,13,15,13, 7,13, 7,19, 9,18, 1,13,15,19, 4,&
15,13,12,14,23,13,15,13,23,23,21,13,15,21,21,23,23,23,23,13,21,16,21,13,16, 1,19,19, 1, 1, 1, 7,&
13,13, 7,13,16, 7,13,16,13,16,18,13,16, 1, 1, 7,18,19, 1,19, 1,19, 1, 1,19/)

REAL, PARAMETER, DIMENSION(N_CBMZ) :: XCONV_FAC_CBMZ=(/&   ! conversion factor
  1.,  2.,  2.,  2.,  2.,  2.,  2.,  2.,  2.,  2.,  2.,  2.,  2.,  2.,  2.,  2.,&
  2.,  2.,  2.,  2.,  2.,  2.,  2.,  2.,  2.,  2.,  2.,  2.,  2.,  2.,  2.,  2.,&
  2.,  2.,  2.,  2.,  3.,  2.,  3.,  3.,  3.,  3.,  3.,  3.,  3.,  3.,  3.,  3.,&
  3.,  3.,  3.,  3.,  3.,  3.,  3.,  3.,  3.,  3.,  3.,  3.,  3.,  3.,  3.,  3.,&
  3.,  3.,  3.,  3.,  3.,  3.,  1.,  3.,  1.,  1.,  1.,  1.,  1.,  1.,  1.,  1.,&
  1.,  1.,  1.,  1.,  3.,  1.,  4.,  1.,  1.,  1.,  1.,  8.,  1., 10.,  3.,  1.,&
  5.,  7.,  6.,  1.,  1.,  3.,  1.,  1.,  8.,  2.,  1.,  7.,  1.,  6.,  1.,  1.,&
  6.,  8.,  6.,  1.,  3.,  1.,  5.,  1.,  1.,  1.,  1.,  2., 12.,  1.,  1.,  1.,&
  1.,  2.,  1.,  1.,  1.,  3.,  1.,  1.,  1.,  1.,  1.,  2.,  2.,  1.,  1.,  1.,&
  1.,  1.,  1.,  1.,  1.,  1.,  1.,  2.,  1.,  2.,  1.,  1.,  2.,  3.,  3.,  1.,&
  4.,  6.,  1.,  3.,  1.,  1.,  6.,  1.,  5.,  1.,  1.,  3.,  1.,  1.,  1.,  1.,&
  1.,  1.,  1.,  1.,  1.,  1.,  1.,  1.,  1./)

!****************************************************************************************************************
!****************************************************************************************************************

INTEGER, PARAMETER :: N_SAPRC99_SPC=28

CHARACTER(LEN=8), DIMENSION(N_SAPRC99_SPC) :: CMECH_SPC_SAPRC99=(/&  ! Mechanism species name
'ISOPRENE','TRP1    ','MEOH    ','ACET    ','CH4     ','NO      ','NO2     ','NH3     ','CCHO    ','HCOOH   ',&
'HCHO    ','CCO_OH  ','BALD    ','MEK     ','RCO_OH  ','CO      ','ETHENE  ','ALK1    ','ALK2    ','ALK3    ',&
'ALK4    ','ALK5    ','ARO1    ','ARO2    ','OLE1    ','OLE2    ','RCHO    ','NONR    '/)


REAL, DIMENSION(N_SAPRC99_SPC) :: XMECH_MWT_SAPRC99=(/&  ! Mechanism species molecular weight
 68.0,136.0, 32.0, 58.0, 16.0, 30.0,44.01, 17.0, 44.0, 46.0, 30.0, 60.0,106.0, 72.0, 74.0, 28.0,&
 28.0, 30.1, 36.7, 58.6, 77.6,118.9, 98.6,118.7, 72.3, 75.8, 58.0,  1.0/)


INTEGER, PARAMETER :: N_SAPRC99=150

CHARACTER(LEN=16), DIMENSION(N_SAPRC99) :: CSPMH_NAM_SAPRC99=(/&   ! speciated species name
'isoprene        ','myrcene         ','sabinene        ','limonene        ','carene_3        ','ocimene_t_b     ',&
'pinene_b        ','pinene_a        ','2met_styrene    ','cymene_p        ','cymene_o        ','phellandrene_a  ',&
'thujene_a       ','terpinene_a     ','terpinene_g     ','terpinolene     ','phellandrene_b  ','camphene        ',&
'bornene         ','fenchene_a      ','ocimene_al      ','ocimene_c_b     ','tricyclene      ','estragole       ',&
'camphor         ','fenchone        ','piperitone      ','thujone_a       ','thujone_b       ','cineole_1_8     ',&
'borneol         ','linalool        ','terpineol_4     ','terpineol_a     ','linalool_OXD_c  ','linalool_OXD_t  ',&
'ionone_b        ','bornyl_ACT      ','farnescene_a    ','caryophyllene_b ','acoradiene      ','aromadendrene   ',&
'bergamotene_a   ','bergamotene_b   ','bisabolene_a    ','bisabolene_b    ','bourbonene_b    ','cadinene_d      ',&
'cadinene_g      ','cedrene_a       ','copaene_a       ','cubebene_a      ','cubebene_b      ','elemene_b       ',&
'farnescene_b    ','germacrene_B    ','germacrene_D    ','gurjunene_b     ','humulene_a      ','humulene_g      ',&
'isolongifolene  ','longifolene     ','longipinene     ','muurolene_a     ','muurolene_g     ','selinene_b      ',&
'selinene_d      ','nerolidol_c     ','nerolidol_t     ','cedrol          ','MBO_2m3e2ol     ','methanol        ',&
'acetone         ','methane         ','ammonia         ','nitrous_OXD     ','nitric_OXD      ','acetaldehyde    ',&
'ethanol         ','formic_acid     ','formaldehyde    ','acetic_acid     ','MBO_3m2e1ol     ','MBO_3m3e1ol     ',&
'benzaldehyde    ','butanone_2      ','decanal         ','dodecene_1      ','geranyl_acetone ','heptanal        ',&
'heptane         ','hexane          ','met_benzoate    ','met_heptenone   ','neryl_acetone   ','nonanal         ',&
'nonenal         ','octanal         ','octanol         ','octenol_1e3ol   ','oxopentanal     ','pentane         ',&
'phenyl_CCO      ','pyruvic_acid    ','terpinyl_ACT_a  ','tetradecene_1   ','toluene         ','carbon_monoxide ',&
'butene          ','ethane          ','ethene          ','hydrogen_cyanide','propane         ','propene         ',&
'carbon_2s       ','carbonyl_s      ','diallyl_2s      ','2met_2s         ','2met_s          ','met_chloride    ',&
'met_bromide     ','met_iodide      ','hydrogen_s      ','met_mercaptan   ','met_propenyl_2s ','PPPP_2s         ',&
'2met_nonatriene ','met_salicylate  ','indole          ','jasmone         ','met_jasmonate   ','3met_3DCTT      ',&
'hexanal         ','hexanol_1       ','hexenal_c3      ','hexenal_t2      ','hexenol_c3      ','hexenyl_ACT_c3  ',&
'homosalate      ','Ehsalate        ','pentanal        ','heptanone       ','anisole         ','verbenene       ',&
'benzyl-acetate  ','myrtenal        ','benzyl-alcohol  ','meta-cymenene   ','ipsenol         ','Napthalene      '/)

INTEGER, DIMENSION(N_SAPRC99) :: NSPMH_MAP_SAPRC99=(/&   ! speciated species name
  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16,&
 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32,&
 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48,&
 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64,&
 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80,&
 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96,&
 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111,112,&
113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,&
129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,&
145,146,147,148,149,150/)

CHARACTER(LEN=8), DIMENSION(N_SAPRC99) :: CMECH_NAM_SAPRC99=(/&   ! mechanism species
'ISOPRENE','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','OLE2    ','ARO2    ',&
'ARO2    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ',&
'TRP1    ','TRP1    ','ALK5    ','TRP1    ','TRP1    ','ALK5    ','TRP1    ','ALK5    ','ALK5    ','ALK5    ',&
'ALK5    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','ALK5    ','TRP1    ','TRP1    ',&
'TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ',&
'TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ',&
'TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','ALK5    ',&
'ISOPRENE','MEOH    ','ACET    ','CH4     ','NH3     ','NONR    ','NO      ','CCHO    ','ALK3    ','HCOOH   ',&
'HCHO    ','CCO_OH  ','ISOPRENE','ISOPRENE','BALD    ','MEK     ','RCHO    ','OLE1    ','TRP1    ','RCHO    ',&
'ALK5    ','ALK4    ','ARO1    ','OLE2    ','OLE2    ','RCHO    ','OLE1    ','RCHO    ','ALK5    ','OLE1    ',&
'RCHO    ','ALK4    ','ARO1    ','RCO_OH  ','TRP1    ','OLE1    ','ARO1    ','CO      ','OLE1    ','ALK1    ',&
'ETHENE  ','NONR    ','ALK2    ','OLE1    ','NONR    ','NONR    ','OLE1    ','ALK5    ','ALK4    ','NONR    ',&
'NONR    ','NONR    ','NONR    ','ALK5    ','OLE1    ','OLE1    ','TRP1    ','ARO1    ','ARO2    ','TRP1    ',&
'TRP1    ','TRP1    ','RCHO    ','ALK5    ','OLE2    ','OLE2    ','OLE2    ','OLE2    ','TRP1    ','TRP1    ',&
'RCHO    ','OLE2    ','BALD    ','ARO2    ','ARO1    ','TRP1    ','ARO1    ','ARO2    ','TRP1    ','ARO2    '/)

INTEGER, DIMENSION(N_SAPRC99) :: NMECH_MAP_SAPRC99=(/&   ! mechanism species mapped
 1, 2, 2, 2, 2, 2, 2, 2,26,24,24, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,22, 2, 2,22, 2,22,22,22,22, 2,&
 2, 2, 2, 2, 2,22, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,&
 2, 2, 2, 2, 2,22, 1, 3, 4, 5, 8,28, 6, 9,20,10,11,12, 1, 1,13,14,27,25, 2,27,22,21,23,26,26,27,&
25,27,22,25,27,21,23,15, 2,25,23,16,25,18,17,28,19,25,28,28,25,22,21,28,28,28,28,22,25,25, 2,23,&
24, 2, 2, 2,27,22,26,26,26,26, 2, 2,27,26,13,24,23, 2,23,24, 2,24/)

REAL, DIMENSION(N_SAPRC99) :: XCONV_FAC_SAPRC99=(/&   ! conversion factor
 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.,&
 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.,&
 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.,&
 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.,&
 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1./)


!****************************************************************************************************************
!****************************************************************************************************************

INTEGER, PARAMETER :: N_SAPRC99_Q_SPC=27

CHARACTER(LEN=8), DIMENSION(N_SAPRC99_Q_SPC) :: CMECH_SPC_SAPRC99_Q=(/&  ! Mechanism species name
'ISOPRENE','TRP1    ','OLE2    ','ARO2    ','ALK5    ','XC      ','OLE1    ','MEOH    ','ACET    ','CH4     ','NH3     ',&
'NO      ','CCHO    ','ALK3    ','HCOOH   ','HCHO    ','CCO_OH  ','BALD    ','MEK     ','RCHO    ','ALK4    ','ARO1    ',&
'BACL    ','CO      ','ALK1    ','ETHENE  ','ALK2    '/)


REAL, DIMENSION(N_SAPRC99_Q_SPC) :: XMECH_MWT_SAPRC99_Q=(/&  ! Mechanism species molecular weight
 68.0,136.0, 75.8,118.7,118.9, 12.0, 72.3, 32.0, 58.0, 16.0, 17.0, 30.0, 44.0, 58.6, 46.0, 30.0,&
 75.0,106.0, 72.0, 58.0, 77.6, 98.6, 86.0, 28.0, 30.1, 92.0, 36.7/)


INTEGER, PARAMETER :: N_SAPRC99_Q=145

CHARACTER(LEN=15), DIMENSION(N_SAPRC99_Q) :: CSPMH_NAM_SAPRC99_Q=(/&   ! speciated species name
'isoprene       ','myrcene        ','sabinene       ','limonene       ','carene_3       ','ocimene_t_b    ',&
'pinene_b       ','pinene_a       ','2met_styrene   ','cymene_p       ','cymene_o       ','phellandrene_a ',&
'thujene_a      ','terpinene_a    ','terpinene_g    ','terpinolene    ','phellandrene_b ','camphene       ',&
'bornene        ','fenchene_a     ','ocimene_al     ','ocimene_c_b    ','tricyclene     ','estragole      ',&
'camphor        ','fenchone       ','piperitone     ','thujone_a      ','thujone_b      ','cineole_1_8    ',&
'borneol        ','linalool       ','terpineol_4    ','terpineol_a    ','linalool_OXD_c ','linalool_OXD_t ',&
'ionone_b       ','bornyl_ACT     ','farnescene_a   ','caryophyllene_b','acoradiene     ','aromadendrene  ',&
'bergamotene_a  ','bergamotene_b  ','bisabolene_a   ','bisabolene_b   ','bourbonene_b   ','cadinene_d     ',&
'cadinene_g     ','cedrene_a      ','copaene_a      ','cubebene_a     ','cubebene_b     ','elemene_b      ',&
'farnescene_b   ','germacrene_B   ','germacrene_D   ','gurjunene_b    ','humulene_a     ','humulene_g     ',&
'isolongifolene ','longifolene    ','longipinene    ','muurolene_a    ','muurolene_g    ','selinene_b     ',&
'selinene_d     ','nerolidol_c    ','nerolidol_t    ','cedrol         ','MBO_2m3e2ol    ','methanol       ',&
'acetone        ','methane        ','ammonia        ','nitric_OXD     ','acetaldehyde   ','ethanol        ',&
'formic_acid    ','formaldehyde   ','acetic_acid    ','MBO_3m2e1ol    ','MBO_3m3e1ol    ','benzaldehyde   ',&
'butanone_2     ','decanal        ','dodecene_1     ','geranyl_acetone','heptanal       ','heptane        ',&
'hexane         ','met_benzoate   ','met_heptenone  ','neryl_acetone  ','nonanal        ','nonenal        ',&
'octanal        ','octanol        ','octenol_1e3ol  ','oxopentanal    ','pentane        ','phenyl_CCO     ',&
'pyruvic_acid   ','terpinyl_ACT_a ','tetradecene_1  ','toluene        ','carbon_monoxide','butene         ',&
'ethane         ','ethene         ','propane        ','propene        ','diallyl_2s     ','2met_2s        ',&
'2met_s         ','met_chloride   ','met_bromide    ','met_iodide     ','met_mercaptan  ','met_propenyl_2s',&
'PPPP_2s        ','2met_nonatriene','met_salicylate ','indole         ','jasmone        ','met_jasmonate  ',&
'3met_3DCTT     ','hexanal        ','hexanol_1      ','hexenal_c3     ','hexenal_t2     ','hexenol_c3     ',&
'hexenyl_ACT_c3 ','homosalate     ','Ehsalate       ','pentanal       ','heptanone      ','anisole        ',&
'verbenene      ','benzyl-acetate ','myrtenal       ','benzyl-alcohol ','meta-cymenene  ','ipsenol        ',&
'Napthalene     '/)

INTEGER, DIMENSION(N_SAPRC99_Q) :: NSPMH_MAP_SAPRC99_Q=(/&   ! speciated species name
  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16,&
 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32,&
 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48,&
 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64,&
 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 77, 78, 79, 80, 81,&
 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97,&
 98, 99,100,101,102,103,104,105,106,107,108,109,110,111,113,114,&
117,118,119,120,121,122,124,125,126,127,128,129,130,131,132,133,&
134,135,136,137,138,134,135,136,137,138,139,140,141,142,143,144,&
145/)

CHARACTER(LEN=8), DIMENSION(N_SAPRC99_Q) :: CMECH_NAM_SAPRC99_Q=(/&   ! mechanism species
'ISOPRENE','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','OLE2    ','ARO2    ',&
'ARO2    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ',&
'TRP1    ','TRP1    ','ALK5    ','TRP1    ','TRP1    ','ALK5    ','TRP1    ','ALK5    ','ALK5    ','ALK5    ',&
'ALK5    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','TRP1    ','ALK5    ','XC      ','XC      ',&
'XC      ','XC      ','XC      ','XC      ','XC      ','XC      ','XC      ','XC      ','XC      ','XC      ',&
'XC      ','XC      ','XC      ','XC      ','XC      ','XC      ','XC      ','XC      ','XC      ','XC      ',&
'XC      ','XC      ','XC      ','XC      ','XC      ','XC      ','XC      ','XC      ','XC      ','ALK5    ',&
'OLE1    ','MEOH    ','ACET    ','CH4     ','NH3     ','NO      ','CCHO    ','ALK3    ','HCOOH   ','HCHO    ',&
'CCO_OH  ','OLE2    ','OLE1    ','BALD    ','MEK     ','RCHO    ','OLE1    ','TRP1    ','RCHO    ','ALK5    ',&
'ALK4    ','ARO1    ','OLE2    ','OLE2    ','RCHO    ','OLE1    ','RCHO    ','ALK5    ','OLE1    ','RCHO    ',&
'ALK4    ','ARO1    ','BACL    ','TRP1    ','OLE1    ','ARO1    ','CO      ','OLE1    ','ALK1    ','ETHENE  ',&
'ALK2    ','OLE1    ','OLE1    ','ALK3    ','ALK4    ','ALK2    ','ALK2    ','ALK2    ','ALK2    ','OLE1    ',&
'OLE1    ','TRP1    ','ARO1    ','ARO2    ','TRP1    ','TRP1    ','XC      ','RCHO    ','ALK5    ','OLE2    ',&
'OLE2    ','OLE2    ','OLE2    ','TRP1    ','TRP1    ','RCHO    ','OLE2    ','BALD    ','ARO2    ','ARO1    ',&
'TRP1    ','ARO1    ','ARO2    ','TRP1    ','ARO2    '/)

INTEGER, DIMENSION(N_SAPRC99_Q) :: NMECH_MAP_SAPRC99_Q=(/&   ! mechanism species mapped
 1, 2, 2, 2, 2, 2, 2, 2, 3, 4, 4, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 5, 2, 2, 5, 2, 5, 5, 5, 5, 2,&
 2, 2, 2, 2, 2, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6,&
 6, 6, 6, 6, 6, 5, 7, 8, 9,10,11,12,13,14,15,16,17, 3, 7,18,19,20, 7, 2,20, 5,21,22, 3, 3,20, 7,&
20, 5, 7,20,21,22,23, 2, 7,22,24, 7,25,26,27, 7, 7,14,21,27,27,27,27, 7, 7, 2,22, 4, 2, 2, 6,20,&
 5, 3, 3, 3, 3, 2, 2,27,26,13,24,23, 2,23,24, 2,24/)

REAL, DIMENSION(N_SAPRC99_Q) :: XCONV_FAC_SAPRC99_Q=(/&   ! conversion factor
 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.,&
 1., 1., 1., 1., 1., 1.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,&
15.,15.,15.,15.,15., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.,&
 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.,16., 1.,&
 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1./)

!****************************************************************************************************************
!****************************************************************************************************************

INTEGER, PARAMETER :: N_SAPRC99_X_SPC=27

CHARACTER(LEN=4), DIMENSION(N_SAPRC99_X_SPC) :: CMECH_SPC_SAPRC99_X=(/&  ! Mechanism species name
'ISOP','TERP','OLE2','ARO2','ALK5','XC  ','OLE1','MEOH','ACET','CH4 ','NH3 ','NO  ','CCHO','ALK3','HC2H','HCHO',&
'CO2H','BALD','MEK ','RCHO','ALK4','ARO1','BACL','CO  ','ALK1','ETHE','ALK2'/)


REAL, DIMENSION(N_SAPRC99_X_SPC) :: XMECH_MWT_SAPRC99_X=(/&  ! Mechanism species molecular weight
 68.0,136.0, 75.8,118.7,118.9, 12.0, 72.3, 32.0, 58.0, 16.0, 17.0, 30.0, 44.0, 58.6, 46.0, 30.0,&
 75.0,106.0, 72.0, 58.0, 77.6, 98.6, 86.0, 28.0, 30.1, 92.0, 36.7/)


INTEGER, PARAMETER :: N_SAPRC99_X=145

CHARACTER(LEN=15), DIMENSION(N_SAPRC99_X) :: CSPMH_NAM_SAPRC99_X=(/&   ! speciated species name
'isoprene       ','myrcene        ','sabinene       ','limonene       ','carene_3       ','ocimene_t_b    ',&
'pinene_b       ','pinene_a       ','2met_styrene   ','cymene_p       ','cymene_o       ','phellandrene_a ',&
'thujene_a      ','terpinene_a    ','terpinene_g    ','terpinolene    ','phellandrene_b ','camphene       ',&
'bornene        ','fenchene_a     ','ocimene_al     ','ocimene_c_b    ','tricyclene     ','estragole      ',&
'camphor        ','fenchone       ','piperitone     ','thujone_a      ','thujone_b      ','cineole_1_8    ',&
'borneol        ','linalool       ','terpineol_4    ','terpineol_a    ','linalool_OXD_c ','linalool_OXD_t ',&
'ionone_b       ','bornyl_ACT     ','farnescene_a   ','caryophyllene_b','acoradiene     ','aromadendrene  ',&
'bergamotene_a  ','bergamotene_b  ','bisabolene_a   ','bisabolene_b   ','bourbonene_b   ','cadinene_d     ',&
'cadinene_g     ','cedrene_a      ','copaene_a      ','cubebene_a     ','cubebene_b     ','elemene_b      ',&
'farnescene_b   ','germacrene_B   ','germacrene_D   ','gurjunene_b    ','humulene_a     ','humulene_g     ',&
'isolongifolene ','longifolene    ','longipinene    ','muurolene_a    ','muurolene_g    ','selinene_b     ',&
'selinene_d     ','nerolidol_c    ','nerolidol_t    ','cedrol         ','MBO_2m3e2ol    ','methanol       ',&
'acetone        ','methane        ','ammonia        ','nitric_OXD     ','acetaldehyde   ','ethanol        ',&
'formic_acid    ','formaldehyde   ','acetic_acid    ','MBO_3m2e1ol    ','MBO_3m3e1ol    ','benzaldehyde   ',&
'butanone_2     ','decanal        ','dodecene_1     ','geranyl_acetone','heptanal       ','heptane        ',&
'hexane         ','met_benzoate   ','met_heptenone  ','neryl_acetone  ','nonanal        ','nonenal        ',&
'octanal        ','octanol        ','octenol_1e3ol  ','oxopentanal    ','pentane        ','phenyl_CCO     ',&
'pyruvic_acid   ','terpinyl_ACT_a ','tetradecene_1  ','toluene        ','carbon_monoxide','butene         ',&
'ethane         ','ethene         ','propane        ','propene        ','diallyl_2s     ','2met_2s        ',&
'2met_s         ','met_chloride   ','met_bromide    ','met_iodide     ','met_mercaptan  ','met_propenyl_2s',&
'PPPP_2s        ','2met_nonatriene','met_salicylate ','indole         ','jasmone        ','met_jasmonate  ',&
'3met_3DCTT     ','hexanal        ','hexanol_1      ','hexenal_c3     ','hexenal_t2     ','hexenol_c3     ',&
'hexenyl_ACT_c3 ','homosalate     ','Ehsalate       ','pentanal       ','heptanone      ','anisole        ',&
'verbenene      ','benzyl-acetate ','myrtenal       ','benzyl-alcohol ','meta-cymenene  ','ipsenol        ',&
'Napthalene     '/)


INTEGER, DIMENSION(N_SAPRC99_X) :: NSPMH_MAP_SAPRC99_X=(/&   ! speciated species name
  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16,&
 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32,&
 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48,&
 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64,&
 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 77, 78, 79, 80, 81,&
 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97,&
 98, 99,100,101,102,103,104,105,106,107,108,109,110,111,113,114,&
117,118,119,120,121,122,124,125,126,127,128,129,130,131,132,133,&
134,135,136,137,138,134,135,136,137,138,139,140,141,142,143,144,&
145/)


CHARACTER(LEN=4), DIMENSION(N_SAPRC99_X) :: CMECH_NAM_SAPRC99_X=(/&   ! mechanism species
'ISOP','TERP','TERP','TERP','TERP','TERP','TERP','TERP','OLE2','ARO2','ARO2','TERP','TERP','TERP','TERP','TERP',&
'TERP','TERP','TERP','TERP','TERP','TERP','ALK5','TERP','TERP','ALK5','TERP','ALK5','ALK5','ALK5','ALK5','TERP',&
'TERP','TERP','TERP','TERP','TERP','ALK5','XC  ','XC  ','XC  ','XC  ','XC  ','XC  ','XC  ','XC  ','XC  ','XC  ',&
'XC  ','XC  ','XC  ','XC  ','XC  ','XC  ','XC  ','XC  ','XC  ','XC  ','XC  ','XC  ','XC  ','XC  ','XC  ','XC  ',&
'XC  ','XC  ','XC  ','XC  ','XC  ','ALK5','OLE1','MEOH','ACET','CH4 ','NH3 ','NO  ','CCHO','ALK3','HC2H','HCHO',&
'CO2H','OLE2','OLE1','BALD','MEK ','RCHO','OLE1','TERP','RCHO','ALK5','ALK4','ARO1','OLE2','OLE2','RCHO','OLE1',&
'RCHO','ALK5','OLE1','RCHO','ALK4','ARO1','BACL','TERP','OLE1','ARO1','CO  ','OLE1','ALK1','ETHE','ALK2','OLE1',&
'OLE1','ALK3','ALK4','ALK2','ALK2','ALK2','ALK2','OLE1','OLE1','TERP','ARO1','ARO2','TERP','TERP','XC  ','RCHO',&
'ALK5','OLE2','OLE2','OLE2','OLE2','TERP','TERP','RCHO','OLE2','BALD','ARO2','ARO1','TERP','ARO1','ARO2','TERP',&
'ARO2'/)

INTEGER, DIMENSION(N_SAPRC99_X) :: NMECH_MAP_SAPRC99_X=(/&   ! mechanism species mapped
 1, 2, 2, 2, 2, 2, 2, 2, 3, 4, 4, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 5, 2, 2, 5, 2, 5, 5, 5, 5, 2,&
 2, 2, 2, 2, 2, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6,&
 6, 6, 6, 6, 6, 5, 7, 8, 9,10,11,12,13,14,15,16,17, 3, 7,18,19,20, 7, 2,20, 5,21,22, 3, 3,20, 7,&
20, 5, 7,20,21,22,23, 2, 7,22,24, 7,25,26,27, 7, 7,14,21,27,27,27,27, 7, 7, 2,22, 4, 2, 2, 6,20,&
 5, 3, 3, 3, 3, 2, 2,27,26,13,24,23, 2,23,24, 2,24/)

REAL, DIMENSION(N_SAPRC99_X) :: XCONV_FAC_SAPRC99_X=(/&   ! conversion factor
 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.,&
 1., 1., 1., 1., 1., 1.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,15.,&
15.,15.,15.,15.,15., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.,&
 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.,16., 1.,&
 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1./)

!****************************************************************************************************************
!****************************************************************************************************************

INTEGER, PARAMETER :: N_SOAX_SPC=8

CHARACTER(LEN=4), DIMENSION(N_SOAX_SPC) :: CMECH_SPC_SOAX=(/&  ! Mechanism species name
'ISP ','TRP ','XYLA','CG5 ','SQT ','TOLA','CG6 ','CG4 '/)

REAL, DIMENSION(N_SOAX_SPC) :: XMECH_MWT_SOAX=(/&  ! Mechanism species molecular weight
 68.,136.,106.,180.,204., 92., 80.,130./)

 
INTEGER, PARAMETER :: N_SOAX=110

CHARACTER(LEN=15), DIMENSION(N_SOAX) :: CSPMH_NAM_SOAX=(/&   ! speciated species name
'isoprene       ','myrcene        ','sabinene       ','limonene       ','carene_3       ','ocimene_t_b    ',&
'pinene_b       ','pinene_a       ','2met_styrene   ','cymene_p       ','cymene_o       ','phellandrene_a ',&
'thujene_a      ','terpinene_a    ','terpinene_g    ','terpinolene    ','phellandrene_b ','camphene       ',&
'bornene        ','fenchene_a     ','ocimene_al     ','ocimene_c_b    ','estragole      ','camphor        ',&
'fenchone       ','piperitone     ','thujone_a      ','thujone_b      ','cineole_1_8    ','borneol        ',&
'linalool       ','terpineol_4    ','terpineol_a    ','linalool_OXD_c ','linalool_OXD_t ','ionone_b       ',&
'bornyl_ACT     ','farnescene_a   ','caryophyllene_b','acoradiene     ','aromadendrene  ','bergamotene_a  ',&
'bergamotene_b  ','bisabolene_a   ','bisabolene_b   ','bourbonene_b   ','cadinene_d     ','cadinene_g     ',&
'cedrene_a      ','copaene_a      ','cubebene_a     ','cubebene_b     ','elemene_b      ','farnescene_b   ',&
'germacrene_B   ','germacrene_D   ','gurjunene_b    ','humulene_a     ','humulene_g     ','isolongifolene ',&
'longifolene    ','longipinene    ','muurolene_a    ','muurolene_g    ','selinene_b     ','selinene_d     ',&
'nerolidol_c    ','nerolidol_t    ','cedrol         ','benzaldehyde   ','decanal        ','geranyl_acetone',&
'heptanal       ','met_benzoate   ','met_heptenone  ','neryl_acetone  ','nonanal        ','nonenal        ',&
'octanal        ','octanol        ','octenol_1e3ol  ','oxopentanal    ','phenyl_CCO     ','pyruvic_acid   ',&
'terpinyl_ACT_a ','toluene        ','2met_nonatriene','met_salicylate ','indole         ','jasmone        ',&
'met_jasmonate  ','3met_3DCTT     ','hexanal        ','hexanol_1      ','hexenal_c3     ','hexenal_t2     ',&
'hexenol_c3     ','hexenyl_ACT_c3 ','homosalate     ','Ehsalate       ','pentanal       ','heptanone      ',&
'anisole        ','verbenene      ','benzyl-acetate ','myrtenal       ','benzyl-alcohol ','meta-cymenene  ',&
'ipsenol        ','Napthalene     '/)

INTEGER, DIMENSION(N_SOAX) :: NSPMH_MAP_SOAX=(/&   ! speciated species name
  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16,&
 17, 18, 19, 20, 21, 22, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33,&
 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49,&
 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65,&
 66, 67, 68, 69, 70, 85, 87, 89, 90, 93, 94, 95, 96, 97, 98, 99,&
100,101,103,104,105,107,127,128,129,130,131,132,133,134,135,136,&
137,138,139,140,141,142,143,144,145,146,147,148,149,150/)

CHARACTER(LEN=16), DIMENSION(N_SOAX) :: CMECH_NAM_SOAX=(/&   ! mechanism species
'ISP ','TRP ','TRP ','TRP ','TRP ','TRP ','TRP ','TRP ','XYLA','XYLA','XYLA','TRP ','TRP ','TRP ','TRP ','TRP ',&
'TRP ','TRP ','TRP ','TRP ','TRP ','TRP ','TRP ','CG5 ','CG5 ','TRP ','CG5 ','CG5 ','CG5 ','CG5 ','TRP ','TRP ',&
'TRP ','TRP ','TRP ','TRP ','CG5 ','SQT ','SQT ','SQT ','SQT ','SQT ','SQT ','SQT ','SQT ','SQT ','SQT ','SQT ',&
'SQT ','SQT ','SQT ','SQT ','SQT ','SQT ','SQT ','SQT ','SQT ','SQT ','SQT ','SQT ','SQT ','SQT ','SQT ','SQT ',&
'SQT ','SQT ','SQT ','SQT ','CG5 ','TOLA','CG5 ','TRP ','CG6 ','TOLA','CG6 ','CG5 ','CG6 ','CG6 ','CG6 ','CG6 ',&
'CG6 ','CG4 ','TOLA','CG4 ','TRP ','TOLA','TRP ','TOLA','TOLA','TRP ','TRP ','SQT ','CG4 ','CG4 ','CG4 ','CG4 ',&
'CG4 ','CG6 ','SQT ','SQT ','CG4 ','CG6 ','TOLA','TRP ','TOLA','TRP ','TOLA','XYLA','TRP ','XYLA'/)

INTEGER, DIMENSION(N_SOAX) :: NMECH_MAP_SOAX=(/&   ! mechanism species mapped
 1, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 4, 4, 2, 4, 4, 4, 4, 2, 2,&
 2, 2, 2, 2, 4, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5,&
 5, 5, 5, 5, 4, 6, 4, 2, 7, 6, 7, 4, 7, 7, 7, 7, 7, 8, 6, 8, 2, 6, 2, 6, 6, 2, 2, 5, 8, 8, 8, 8,&
 8, 7, 5, 5, 8, 7, 6, 2, 6, 2, 6, 3, 2, 3/)

REAL, DIMENSION(N_SOAX) :: XCONV_FAC_SOAX=(/&   ! conversion factor
 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0,&
 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0,0.85,0.85, 1.0,0.85,0.85,0.86,0.86, 1.0, 1.0,&
 1.0, 1.0, 1.0, 1.0,1.09, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0,&
 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0,&
 1.0, 1.0, 1.0, 1.0,1.24, 1.0,0.87, 1.0,0.63, 1.0,0.70,1.08,0.79,0.78,0.71,0.72,&
0.71,0.77, 1.0,0.68, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0,0.77,0.79,0.76,0.76,&
0.77,0.79, 1.0, 1.0,0.77,0.70, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0/)

!****************************************************************************************************************
!****************************************************************************************************************

INTEGER,PARAMETER :: N_SPCA_SPC = 150                   ! Number of speciated species

CHARACTER(LEN=17), DIMENSION(N_SPCA_SPC) :: CSPCA_SPC=(/&   ! speciated species name
'isoprene         ','myrcene          ','sabinene         ','limonene         ','carene_3         ','ocimene_t_b      ',&
'pinene_b         ','pinene_a         ','A_2met_styrene   ','cymene_p         ','cymene_o         ','phellandrene_a   ',&
'thujene_a        ','terpinene_a      ','terpinene_g      ','terpinolene      ','phellandrene_b   ','camphene         ',&
'bornene          ','fenchene_a       ','ocimene_al       ','ocimene_c_b      ','tricyclene       ','estragole        ',&
'camphor          ','fenchone         ','piperitone       ','thujone_a        ','thujone_b        ','cineole_1_8      ',&
'borneol          ','linalool         ','terpineol_4      ','terpineol_a      ','linalool_OXD_c   ','linalool_OXD_t   ',&
'ionone_b         ','bornyl_ACT       ','farnescene_a     ','caryophyllene_b  ','acoradiene       ','aromadendrene    ',&
'bergamotene_a    ','bergamotene_b    ','bisabolene_a     ','bisabolene_b     ','bourbonene_b     ','cadinene_d       ',&
'cadinene_g       ','cedrene_a        ','copaene_a        ','cubebene_a       ','cubebene_b       ','elemene_b        ',&
'farnescene_b     ','germacrene_B     ','germacrene_D     ','gurjunene_b      ','humulene_a       ','humulene_g       ',&
'isolongifolene   ','longifolene      ','longipinene      ','muurolene_a      ','muurolene_g      ','selinene_b       ',&
'selinene_d       ','nerolidol_c      ','nerolidol_t      ','cedrol           ','MBO_2m3e2ol      ','methanol         ',&
'acetone          ','methane          ','ammonia          ','nitrous_OXD      ','nitric_OXD       ','acetaldehyde     ',&
'ethanol          ','formic_acid      ','formaldehyde     ','acetic_acid      ','MBO_3m2e1ol      ','MBO_3m3e1ol      ',&
'benzaldehyde     ','butanone_2       ','decanal          ','dodecene_1       ','geranyl_acetone  ','heptanal         ',&
'heptane          ','hexane           ','met_benzoate     ','met_heptenone    ','neryl_acetone    ','nonanal          ',&
'nonenal          ','octanal          ','octanol          ','octenol_1e3ol    ','oxopentanal      ','pentane          ',&
'phenyl_CCO       ','pyruvic_acid     ','terpinyl_ACT_a   ','tetradecene_1    ','toluene          ','carbon_monoxide  ',&
'butene           ','ethane           ','ethene           ','hydrogen_cyanide ','propane          ','propene          ',&
'carbon_2s        ','carbonyl_s       ','diallyl_2s       ','A_2met_2s        ','A_2met_s         ','met_chloride     ',&
'met_bromide      ','met_iodide       ','hydrogen_s       ','met_mercaptan    ','met_propenyl_2s  ','PPPP_2s          ',&
'A_2met_nonatriene','met_salicylate   ','indole           ','jasmone          ','met_jasmonate    ','A_3met_3DCTT     ',&
'hexanal          ','hexanol_1        ','hexenal_c3       ','hexenal_t2       ','hexenol_c3       ','hexenyl_ACT_c3   ',&
'homosalate       ','Ehsalate         ','pentanal         ','heptanone        ','anisole          ','verbenene        ',&
'benzyl-acetate   ','myrtenal         ','benzyl-alcohol   ','meta-cymenene    ','ipsenol          ','Napthalene       '/)

REAL, DIMENSION(N_SPCA_SPC) :: XSPCA_MWT=(/&                ! Mechanism species molecular weight
 68.12,136.23,136.23,136.23,136.23,136.23,136.23,136.23,132.20,134.22,134.22,136.23,136.23,136.23,136.23,136.23,&
136.23,136.23,136.23,136.23,136.23,136.23,136.23,148.20,152.23,152.23,152.23,152.23,152.23,154.25,154.25,154.25,&
154.25,154.25,170.25,170.25,192.30,196.29,204.35,204.35,204.35,204.35,204.35,204.35,204.35,204.35,204.35,204.35,&
204.35,204.35,204.35,204.35,204.35,204.35,204.35,204.35,204.35,204.35,204.35,204.35,204.35,204.35,204.35,204.35,&
204.35,204.35,204.35,222.37,222.37,222.37, 86.13, 32.04, 58.08, 16.04, 17.03, 44.01, 30.01, 44.05, 46.07, 46.03,&
 30.03, 60.05, 86.13, 86.13,106.12, 72.11,156.27,168.32,194.31,114.19,100.20, 86.18,136.15,126.20,194.31,142.24,&
140.22,128.21,130.23,128.21,100.12, 72.15,120.15, 88.06,196.29,196.37, 92.14, 28.01, 56.11, 30.07, 28.05, 27.03,&
 44.10, 42.08, 76.14, 60.08,146.28, 94.20, 62.14, 50.49, 94.94,141.94, 34.08, 48.11,120.24,148.29,150.26,152.15,&
117.15,164.24,224.30,218.38,100.16,102.17, 98.14, 98.14,100.16,142.20,  131.,  131.,  133.,   94.,   85.,   10.,&
   85.,   32.,   85.,   10.,   32.,  129./)

!****************************************************************************************************************
!****************************************************************************************************************
      
INTEGER,PARAMETER :: N_SMAP_SPC = 150   ! Number of map species

CHARACTER(LEN=17), DIMENSION(N_SMAP_SPC) :: CSPCA_NAM=(/&  ! speciated species name
'isoprene         ','myrcene          ','sabinene         ','limonene         ','carene_3         ','ocimene_t_b      ',&
'pinene_b         ','pinene_a         ','A_2met_styrene   ','cymene_p         ','cymene_o         ','phellandrene_a   ',&
'thujene_a        ','terpinene_a      ','terpinene_g      ','terpinolene      ','phellandrene_b   ','camphene         ',&
'bornene          ','fenchene_a       ','ocimene_al       ','ocimene_c_b      ','tricyclene       ','estragole        ',&
'camphor          ','fenchone         ','piperitone       ','thujone_a        ','thujone_b        ','cineole_1_8      ',&
'borneol          ','linalool         ','terpineol_4      ','terpineol_a      ','linalool_OXD_c   ','linalool_OXD_t   ',&
'ionone_b         ','bornyl_ACT       ','farnescene_a     ','caryophyllene_b  ','acoradiene       ','aromadendrene    ',&
'bergamotene_a    ','bergamotene_b    ','bisabolene_a     ','bisabolene_b     ','bourbonene_b     ','cadinene_d       ',&
'cadinene_g       ','cedrene_a        ','copaene_a        ','cubebene_a       ','cubebene_b       ','elemene_b        ',&
'farnescene_b     ','germacrene_B     ','germacrene_D     ','gurjunene_b      ','humulene_a       ','humulene_g       ',&
'isolongifolene   ','longifolene      ','longipinene      ','muurolene_a      ','muurolene_g      ','selinene_b       ',&
'selinene_d       ','nerolidol_c      ','nerolidol_t      ','cedrol           ','MBO_2m3e2ol      ','methanol         ',&
'acetone          ','methane          ','ammonia          ','nitrous_OXD      ','nitric_OXD       ','acetaldehyde     ',&
'ethanol          ','formic_acid      ','formaldehyde     ','acetic_acid      ','MBO_3m2e1ol      ','MBO_3m3e1ol      ',&
'benzaldehyde     ','butanone_2       ','decanal          ','dodecene_1       ','geranyl_acetone  ','heptanal         ',&
'heptane          ','hexane           ','met_benzoate     ','met_heptenone    ','neryl_acetone    ','nonanal          ',&
'nonenal          ','octanal          ','octanol          ','octenol_1e3ol    ','oxopentanal      ','pentane          ',&
'phenyl_CCO       ','pyruvic_acid     ','terpinyl_ACT_a   ','tetradecene_1    ','toluene          ','carbon_monoxide  ',&
'butene           ','ethane           ','ethene           ','hydrogen_cyanide ','propane          ','propene          ',&
'carbon_2s        ','carbonyl_s       ','diallyl_2s       ','A_2met_2s        ','A_2met_s         ','met_chloride     ',&
'met_bromide      ','met_iodide       ','hydrogen_s       ','met_mercaptan    ','met_propenyl_2s  ','PPPP_2s          ',&
'A_2met_nonatriene','met_salicylate   ','indole           ','jasmone          ','met_jasmonate    ','3met_3DCTT       ',&
'hexanal          ','hexanol_1        ','hexenal_c3       ','hexenal_t2       ','hexenol_c3       ','hexenyl_ACT_c3   ',&
'homosalate       ','Ehsalate         ','pentanal         ','heptanone        ','anisole          ','verbenene        ',&
'benzyl-acetate   ','myrtenal         ','benzyl-alcohol   ','meta-cymenene    ','ipsenol          ','Napthalene       '/)

INTEGER, DIMENSION(N_SMAP_SPC) :: NSPCA_MAP=(/&             ! speciated species name
  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16,&
 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32,&
 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48,&
 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64,&
 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80,&
 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96,&
 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111,112,&
113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,&
129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,&
145,146,147,148,149,150/)
                                                      
CHARACTER(LEN=6), DIMENSION(N_SMAP_SPC) :: CMG20_NAM=(/&   ! MEGAN species
'ISOP  ','MYRC  ','SABI  ','LIMO  ','3CAR  ','OCIM  ','BPIN  ','APIN  ','OMTP  ','OMTP  ',&
'OMTP  ','OMTP  ','OMTP  ','OMTP  ','OMTP  ','OMTP  ','OMTP  ','OMTP  ','OMTP  ','OMTP  ',&
'OMTP  ','OMTP  ','OMTP  ','OMTP  ','OMTP  ','OMTP  ','OMTP  ','OMTP  ','OMTP  ','OMTP  ',&
'OMTP  ','OMTP  ','OMTP  ','OMTP  ','OMTP  ','OMTP  ','OMTP  ','OMTP  ','FARN  ','BCAR  ',&
'OSQT  ','OSQT  ','OSQT  ','OSQT  ','OSQT  ','OSQT  ','OSQT  ','OSQT  ','OSQT  ','OSQT  ',&
'OSQT  ','OSQT  ','OSQT  ','OSQT  ','OSQT  ','OSQT  ','OSQT  ','OSQT  ','OSQT  ','OSQT  ',&
'OSQT  ','OSQT  ','OSQT  ','OSQT  ','OSQT  ','OSQT  ','OSQT  ','OSQT  ','OSQT  ','OSQT  ',&
'MBO   ','MEOH  ','ACTO  ','OTHER ','NO    ','NO    ','NO    ','BIDIR ','BIDIR ','BIDIR ',&
'BIDIR ','BIDIR ','OTHER ','OTHER ','OTHER ','OTHER ','OTHER ','OTHER ','OTHER ','OTHER ',&
'OTHER ','OTHER ','OTHER ','OTHER ','OTHER ','OTHER ','OTHER ','OTHER ','OTHER ','OTHER ',&
'OTHER ','OTHER ','OTHER ','OTHER ','OTHER ','OTHER ','STRESS','CO    ','OTHER ','OTHER ',&
'STRESS','STRESS','OTHER ','OTHER ','OTHER ','OTHER ','OTHER ','OTHER ','OTHER ','OTHER ',&
'OTHER ','OTHER ','OTHER ','OTHER ','OTHER ','OTHER ','STRESS','STRESS','STRESS','STRESS',&
'STRESS','STRESS','STRESS','STRESS','STRESS','STRESS','STRESS','STRESS','OTHER ','OTHER ',&
'OTHER ','OTHER ','OTHER ','OMTP  ','OTHER ','OMTP  ','OTHER ','OMTP  ','OMTP  ','OTHER '/)

INTEGER, DIMENSION(N_SMAP_SPC) :: NMG20_MAP=(/&            ! MEGAN species mapped to
 1, 2, 3, 4, 5, 6, 7, 8, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9,&
 9, 9, 9, 9, 9, 9,10,11,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,&
12,12,12,12,12,12,13,14,15,20,17,17,17,18,18,18,18,18,20,20,20,20,20,20,20,20,20,20,20,20,20,20,&
20,20,20,20,20,20,20,20,20,20,19,16,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,&
19,19,19,19,19,19,19,19,19,19,20,20,20,20,20, 9,20, 9,20, 9, 9,20/)

END MODULE MODD_MGN2MECH
