!SFX_LIC Copyright 1994-2014 CNRS, Meteo-France and Universite Paul Sabatier
!SFX_LIC This is part of the SURFEX software governed by the CeCILL-C licence
!SFX_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt  
!SFX_LIC for details. version 1.
!     ##################
      MODULE MODN_ASSIM
!     ##################
!
!!****  *MODN_ASSIM - declaration of keys for ISBA assimilation scheme (2DVAR, Bouyssel et al.)
!!
!!    PURPOSE
!!    -------
!
!!
!!**  IMPLICIT ARGUMENTS
!!    ------------------
!!      None 
!!
!!    REFERENCE
!!    ---------
!!
!!    AUTHOR
!!    ------
!!      L. Jarlan   *Meteo France*
!!
!!    MODIFICATIONS
!!    -------------
!!      Original       23/02/05
!!      Merge assimilation   T. Aspelien met.no (04/2012)
!
!*       0.   DECLARATIONS
!             ------------
!
USE MODD_ASSIM, ONLY:  LASSIM,CASSIM,CASSIM_ISBA,NPRINTLEV,LAROME,LECSST,LAESST,LAESNM,LWATERTG2, &
                       LALADSURF,LREAD_SST_FROM_FILE,CFILE_FORMAT_SST,LEXTRAP_SEA,LEXTRAP_WATER,  &
                       LEXTRAP_NATURE,NECHGU,XRCLIMCA,XRCLISST,XSIGH2MO,XSIGT2MO,XSIGWGO,XSIGWGB, &
                       XSIGW2B,LOBSWG,LOBS2M,LIMVEG,XSPRECIP2,XRTHR_QC,XSIGWGO_MAX,XRSCAL_JAC,    &
                       CBIO,LPRT,LBEV,LBFIXED,NOBSTYPE,COBS_M,XERROBS_M,NNCO,NIVAR,NVAR,CVAR_M,   &
                       LSIM,XSIGMA_M,XTPRT_M,NNCV,XSCALE_Q,XSCALE_QLAI,XALPH,LOBSHEADER,LOBSNAT,  &
                       CFILE_FORMAT_OBS,CFILE_FORMAT_LSM,CFILE_FORMAT_CLIM,CFILE_FORMAT_FG,       &
                       NBOUTPUT,CPREFIX_M,CPREFIX_BIO,LENKF,LDENKF,XASSIM_WINH,NENS,NIE,XINFL_M,  &
                       XADDINFL_M,XADDTIMECORR_M,LENS_GEN,LPB_CORRELATIONS,LPERTURBATION_RUN,     &
                       LBIAS_CORRECTION
!
IMPLICIT NONE
!
NAMELIST/NAM_ASSIM/LASSIM,CASSIM,CASSIM_ISBA,NPRINTLEV,LAROME,LECSST,LAESST,LAESNM,LALADSURF,    &
                   LREAD_SST_FROM_FILE,CFILE_FORMAT_SST,LEXTRAP_SEA,LEXTRAP_WATER,LEXTRAP_NATURE,&
                   LWATERTG2,NBOUTPUT,CFILE_FORMAT_LSM,CFILE_FORMAT_CLIM,CFILE_FORMAT_FG
NAMELIST/NAM_NACVEG/NECHGU,XRCLIMCA,XRCLISST,XSIGH2MO,XSIGT2MO,XSIGWGO,XSIGWGB,XSIGW2B,  &
                    LOBSWG,LOBS2M,LIMVEG,XSPRECIP2,XRTHR_QC,XSIGWGO_MAX,XRSCAL_JAC
NAMELIST/NAM_IO_VARASSIM/LPRT, LSIM, LBEV, LBFIXED
NAMELIST/NAM_OBS/NOBSTYPE,LOBSHEADER,CFILE_FORMAT_OBS, LOBSNAT, COBS_M, XERROBS_M, NNCO
NAMELIST/NAM_VAR/NIVAR, NVAR, CVAR_M, CPREFIX_M, XSIGMA_M, XTPRT_M, NNCV, XSCALE_Q, XSCALE_QLAI, &
                 CBIO, CPREFIX_BIO, XALPH
NAMELIST/NAM_ENS/NENS, NIE, XASSIM_WINH, XINFL_M, XADDINFL_M, XADDTIMECORR_M, &
                 LENS_GEN, LPB_CORRELATIONS, LPERTURBATION_RUN, LBIAS_CORRECTION, LENKF, LDENKF
!
END MODULE MODN_ASSIM
